# ImageCore

[![][action-img]][action-url]
[![][pkgeval-img]][pkgeval-url]
[![][codecov-img]][codecov-url]
[![][docs-stable-img]][docs-stable-url]
[![][docs-dev-img]][docs-dev-url]

ImageCore is the lowest-level component of the system of packages
designed to support image processing and computer vision.


<!-- URLS -->

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/I/ImageCore.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/report.html
[action-img]: https://github.com/JuliaImages/ImageCore.jl/actions/workflows/UnitTest.yml/badge.svg
[action-url]: https://github.com/JuliaImages/ImageCore.jl/actions
[codecov-img]: https://codecov.io/github/JuliaImages/ImageCore.jl/coverage.svg?branch=master
[codecov-url]: https://codecov.io/github/JuliaImages/ImageCore.jl?branch=master
[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://JuliaImages.github.io/ImageCore.jl/stable
[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://JuliaImages.github.io/ImageCore.jl/latest

using ImageCore
using FFTW
using Logging
using Test

@testset "functions" begin
    ag = rand(Gray{Float32}, 4, 5)
    ac = rand(RGB{Float32}, 4, 5)
    for (f, args) in ((fft, (ag,)), (fft, (ag, 1:2)), (plan_fft, (ag,)),
                      (rfft, (ag,)), (rfft, (ag, 1:2)), (plan_rfft, (ag,)),
                      (fft, (ac,)), (fft, (ac, 1:2)), (plan_fft, (ac,)),
                      (rfft, (ac,)), (rfft, (ac, 1:2)), (plan_rfft, (ac,)))
        dims_str = eltype(args[1])<:Gray ? "1:2" : "2:3"
        @test_throws "channelview, and likely $dims_str" f(args...)
    end
    for (a, dims) in ((ag, 1:2), (ac, 2:3))
        @test ifft(fft(channelview(a), dims), dims) ≈ channelview(a)
        ret = @test_throws "channelview, and likely $dims" rfft(a)
        @test irfft(rfft(channelview(a), dims), 4, dims) ≈ channelview(a)
    end
    # Ensure that the hint doesn't error
    @test_logs min_level=Logging.Warn try
        [3](1, 2)
    catch err
        showerror(devnull, err)
    end

    a = [RGB(1,0,0), RGB(0,1,0), RGB(0,0,1)]
    @test a' == [RGB(1,0,0) RGB(0,1,0) RGB(0,0,1)]

    a = [RGB(1,0,0) RGB(0,1,0); RGB(0,0,1) RGB(0, 0, 0)]
    @test a' == [RGB(1,0,0) RGB(0,0,1); RGB(0,1,0) RGB(0, 0, 0)]
end

nothing

"""
    HasProperties(img) -> HasProperties{::Bool}

Returns the trait `HasProperties`, indicating whether `x` has `properties`
method.
"""
struct HasProperties{T} end

HasProperties(img::T) where T = HasProperties(T)

HasProperties(::Type{T}) where T = HasProperties{false}()

"""
    HasDimNames(img) -> HasDimNames{::Bool}

Returns the trait `HasDimNames`, indicating whether `x` has named dimensions.
Types returning `HasDimNames{true}()` should also have a `names` method that
returns a tuple of symbols for each dimension.
"""
struct HasDimNames{T} end

HasDimNames(img::T) where T = HasDimNames(T)

HasDimNames(::Type{T}) where T = HasDimNames{false}()

"""
    namedaxes(img) -> NamedTuple{names}(axes)

Returns a `NamedTuple` where the names are the dimension names and each indice
is the corresponding dimensions's axis. If `HasDimNames` is not defined for `x`
default names are returned. `x` should have an `axes` method.

```jldoctest; setup = :(using ImageCore)
julia> img = reshape(1:24, 2,3,4);

julia> namedaxes(img)
(dim_1 = Base.OneTo(2), dim_2 = Base.OneTo(3), dim_3 = Base.OneTo(4))
```
"""
namedaxes(img::T) where T = namedaxes(HasDimNames(T), img)

namedaxes(::HasDimNames{true}, x::T) where T = NamedTuple{names(x)}(axes(x))

function namedaxes(::HasDimNames{false}, img::AbstractArray{T,N}) where {T,N}
    NamedTuple{default_names(Val(N))}(axes(img))
end

@generated function default_names(img::Val{N}) where {N}
    :($(ntuple(i -> Symbol(:dim_, i), N)))
end

"""
    pixelspacing(img) -> (sx, sy, ...)

Return a tuple representing the separation between adjacent pixels
along each axis of the image.  Defaults to (1,1,...).  Use
ImagesAxes for images with anisotropic spacing or to encode the
spacing using physical units.
"""
pixelspacing(img::AbstractArray{T,N}) where {T,N} = ntuple(d->1, Val(N))
# Some of these traits need to work recursively into "container" types
pixelspacing(img::AbstractMappedArray) = pixelspacing(parent(img))
function pixelspacing(img::AbstractMultiMappedArray)
    ps = traititer(pixelspacing, parent(img)...)
    checksame(ps)
end
pixelspacing(img::OffsetArray) = pixelspacing(parent(img))
@inline pixelspacing(img::SubArray) =
    _subarray_filter(pixelspacing(parent(img)), img.indices...)
@inline pixelspacing(img::Base.PermutedDimsArrays.PermutedDimsArray{T,N,perm}) where {T,N,perm} =
    _getindex_tuple(pixelspacing(parent(img)), perm)

"""
    spacedirections(img) -> (axis1, axis2, ...)

Return a tuple-of-tuples, each `axis[i]` representing the displacement
vector between adjacent pixels along spatial axis `i` of the image
array, relative to some external coordinate system ("physical
coordinates").

By default this is computed from `pixelspacing`, but you can set this
manually using ImagesMeta.
"""
spacedirections(img::AbstractArray) = _spacedirections(pixelspacing(img))
spacedirections(img::AbstractMappedArray) = spacedirections(parent(img))
function spacedirections(img::AbstractMultiMappedArray)
    ps = traititer(spacedirections, parent(img)...)
    checksame(ps)
end
spacedirections(img::OffsetArray) = spacedirections(parent(img))
@inline spacedirections(img::SubArray) =
    _subarray_filter(spacedirections(parent(img)), img.indices...)
@inline spacedirections(img::Base.PermutedDimsArrays.PermutedDimsArray{T,N,perm}) where {T,N,perm} =
    _getindex_tuple(spacedirections(parent(img)), perm)

function _spacedirections(ps::NTuple{N,Any}) where N
    ntuple(i->ntuple(d->d==i ? ps[d] : zero(ps[d]), Val(N)), Val(N))
end

"""
    sdims(img)

Return the number of spatial dimensions in the image. Defaults to the
same as `ndims`, but with ImagesAxes you can specify that some axes
correspond to other quantities (e.g., time) and thus not included by
`sdims`.
"""
sdims(img::AbstractArray) = length(coords_spatial(img))

"""
   coords_spatial(img)

Return a tuple listing the spatial dimensions of `img`.

Note that a better strategy may be to use ImagesAxes and take slices along the time axis.
"""
@inline coords_spatial(img::AbstractArray{T,N}) where {T,N} = ntuple(identity, Val(N))

coords_spatial(img::AbstractMappedArray) = coords_spatial(parent(img))
function coords_spatial(img::AbstractMultiMappedArray)
    ps = traititer(coords_spatial, parent(img)...)
    checksame(ps)
end
coords_spatial(img::OffsetArray) = coords_spatial(parent(img))
@inline coords_spatial(img::SubArray) =
    _subarray_offset(0, coords_spatial(parent(img)), img.indices...)
@inline coords_spatial(img::Base.PermutedDimsArrays.PermutedDimsArray{T,N,perm,iperm}) where {T,N,perm,iperm} =
    _getindex_tuple(coords_spatial(parent(img)), iperm)



"""
    nimages(img)

Return the number of time-points in the image array. Defaults to
1. Use ImagesAxes if you want to use an explicit time dimension.
"""
nimages(img::AbstractArray) = 1
nimages(img::AbstractMappedArray) = nimages(parent(img))
function nimages(img::AbstractMultiMappedArray)
    ps = traititer(nimages, parent(img)...)
    checksame(ps)
end
nimages(img::OffsetArray) = nimages(parent(img))
nimages(img::SubArray) = nimages(parent(img))
nimages(img::Base.PermutedDimsArrays.PermutedDimsArray) = nimages(parent(img))

"""
    size_spatial(img)

Return a tuple listing the sizes of the spatial dimensions of the
image. Defaults to the same as `size`, but using ImagesAxes you can
mark some axes as being non-spatial.
"""
size_spatial(img) = size(img)
size_spatial(img::AbstractMappedArray) = size_spatial(parent(img))
function size_spatial(img::AbstractMultiMappedArray)
    ps = traititer(size_spatial, parent(img)...)
    checksame(ps)
end
size_spatial(img::OffsetArray) = size_spatial(parent(img))
@inline size_spatial(img::SubArray) =
    _subarray_filter(size_spatial(parent(img)), img.indices...)
@inline size_spatial(img::Base.PermutedDimsArrays.PermutedDimsArray{T,N,perm}) where {T,N,perm} =
    _getindex_tuple(size_spatial(parent(img)), perm)

"""
    indices_spatial(img)

Return a tuple with the indices of the spatial dimensions of the
image. Defaults to the same as `indices`, but using ImagesAxes you can
mark some axes as being non-spatial.
"""
indices_spatial(img) = axes(img)
indices_spatial(img::AbstractMappedArray) = indices_spatial(parent(img))
function indices_spatial(img::AbstractMultiMappedArray)
    ps = traititer(indices_spatial, parent(img)...)
    checksame(ps)
end
@inline indices_spatial(img::SubArray) =
    _subarray_filter(indices_spatial(parent(img)), img.indices...)
@inline indices_spatial(img::Base.PermutedDimsArrays.PermutedDimsArray{T,N,perm}) where {T,N,perm} =
    _getindex_tuple(indices_spatial(parent(img)), perm)

#### Utilities for writing "simple algorithms" safely ####
# If you don't feel like supporting multiple representations, call these

"""
    assert_timedim_last(img)

Throw an error if the image has a time dimension that is not the last
dimension.
"""
assert_timedim_last(img::AbstractArray) = nothing
assert_timedim_last(img::AbstractMappedArray) = assert_timedim_last(parent(img))
function assert_timedim_last(img::AbstractMultiMappedArray)
    traititer(assert_timedim_last, parent(img)...)
    return nothing
end
assert_timedim_last(img::OffsetArray) = assert_timedim_last(parent(img))
assert_timedim_last(img::SubArray) = assert_timedim_last(parent(img))



# Traits whose only meaningful definitions occur in ImageAxes, but for
# which we want nesting behavior
spatialorder(img::AbstractMappedArray) = spatialorder(parent(img))
function spatialorder(img::AbstractMultiMappedArray)
    ps = traititer(spatialorder, parent(img)...)
    checksame(ps)
end
spatialorder(img::OffsetArray) = spatialorder(parent(img))
@inline spatialorder(img::Base.PermutedDimsArrays.PermutedDimsArray{T,N,perm}) where {T,N,perm} =
    _getindex_tuple(spatialorder(parent(img)), perm)

# Utilities

@inline traititer(f, A, rest...) = (f(A), traititer(f, rest...)...)
@inline traititer(f, A::ZeroArray, rest...) = traititer(f, rest...)
traititer(f) = ()

function checksame(t::Tuple)
    val1 = t[1]
    @assert all(p -> p == val1, t)
    return val1
end

@inline _subarray_filter(x, i::Real, inds...) =
    _subarray_filter(tail(x), inds...)
@inline _subarray_filter(x, i, inds...) =
    (x[1], _subarray_filter(tail(x), inds...)...)
_subarray_filter(x::Tuple{}) = ()

@inline _subarray_offset(off, x, i::Real, inds...) =
    _subarray_offset(off-1, tail(x), inds...)
@inline _subarray_offset(off, x, i, inds...) =
    (x[1]+off, _subarray_offset(off, tail(x), inds...)...)
_subarray_offset(off, x::Tuple{}) = ()

@inline _getindex_tuple(t::Tuple, inds::Tuple) =
    (t[inds[1]], _getindex_tuple(t, tail(inds))...)
_getindex_tuple(t::Tuple, ::Tuple{}) = ()

const warned_once = Ref(false)
function forced_depwarn(msg, sym)
    opts = Base.JLOptions()
    if !warned_once[] && !(opts.depwarn == 1)
        @warn msg
        @info """It is recommended that you fix this now to avoid breakage when a new version is released and this warning is removed.
                    Tip: to see all deprecation warnings together with code locations, launch Julia with `--depwarn=yes` and rerun your code."""
        warned_once[] = true
    else
        Base.depwarn(msg, sym)
    end
    return nothing
end

# a perhaps "permanent" deprecation
Base.@deprecate_binding permuteddimsview PermutedDimsArray

using ImageCore, Colors, FixedPointNumbers, OffsetArrays
using Test, Random

@testset "reinterpret" begin
    # Gray
    for sz in ((4,), (4,5))
        a = rand(Gray{N0f8}, sz)
        for T in (Gray{N0f8}, Gray{Float32}, Gray{Float64})
            b = @inferred(map(T, a))
            rb = @inferred(reinterpretc(eltype(T), b))
            @test eltype(rb) == eltype(T) && ndims(rb) == length(sz)
            @test size(rb) == sz
            c = copy(rb)
            rc = @inferred(reinterpretc(T, c))
            @test eltype(rc) == T && ndims(rc) == length(sz)
            @test size(rc) == sz
        end
    end
    for sz in ((4,), (4,5))
        # Bool/Gray{Bool}
        b = rand(Bool, sz)
        rb = @inferred(reinterpretc(Gray{Bool}, b))
        @test eltype(rb) == Gray{Bool} && ndims(rb) == length(sz)
        @test size(rb) == sz
        c = copy(rb)
        rc = @inferred(reinterpretc(Bool, c))
        @test eltype(rc) == Bool && ndims(rc) == length(sz)
        @test size(rc) == sz
    end
    for sz in ((4,), (4,5))
        b = Gray24.(reinterpret(N0f8, rand(UInt8, sz)))
        for T in (UInt32, RGB24)
            rb = @inferred(reinterpretc(T, b))
            @test eltype(rb) == T && ndims(rb) == length(sz)
            @test size(rb) == sz
            c = copy(rb)
            rc = @inferred(reinterpretc(Gray24, c))
            @test eltype(rc) == Gray24 && ndims(rc) == length(sz)
            @test size(rc) == sz
        end
    end
    # TransparentGray
    a = rand(AGray{N0f8}, (4,5))
    for T in (AGray{N0f8}, GrayA{Float32}, AGray{Float64})
        b = @inferred(broadcast(T, a))
        rb = @inferred(reinterpretc(eltype(T), b))
        @test eltype(rb) == eltype(T) && ndims(rb) == 3
        @test size(rb) == (2,4,5)
        c = copy(rb)
        rc = @inferred(reinterpretc(T, c))
        @test eltype(rc) == T && ndims(rc) == 2
        @test size(rc) == (4,5)
    end
    # Color3
    a = rand(RGB{N0f8}, (4,5))
    for T in (RGB{N0f8}, HSV{Float32}, XYZ{Float64})
        b = @inferred(broadcast(T, a))
        rb = @inferred(reinterpretc(eltype(T), b))
        @test eltype(rb) == eltype(T) && ndims(rb) == 3
        @test size(rb) == (3,4,5)
        c = copy(rb)
        rc = @inferred(reinterpretc(T, c))
        @test eltype(rc) == T && ndims(rc) == 2
        @test size(rc) == (4,5)
    end
    for a in (rand(RGB{N0f8}, 4), rand(RGB{N0f8}, (4,5)))
        b = @inferred(reinterpretc(HSV{Float32}, float32.(a)))
        @test eltype(b) == HSV{Float32}
        @test ndims(b) == ndims(a)
    end
    # Transparent color
    a = rand(ARGB{N0f8}, (4,5))
    for T in (ARGB{N0f8}, AHSV{Float32}, AXYZ{Float64})
        b = @inferred(broadcast(T, a))
        rb = @inferred(reinterpretc(eltype(T), b))
        @test eltype(rb) == eltype(T) && ndims(rb) == 3
        @test size(rb) == (4,4,5)
        c = copy(rb)
        rc = @inferred(reinterpretc(T, c))
        @test eltype(rc) == T && ndims(rc) == 2
        @test size(rc) == (4,5)
    end
    # XRGB/RGBX
    a = rand(RGB{N0f8}, (4,5))
    for T in (XRGB{N0f8},RGBX{Float32})
        b = @inferred(broadcast(T, a))
        rb = @inferred(reinterpretc(eltype(T), b))
        @test eltype(rb) == eltype(T) && ndims(rb) == 3
        @test size(rb) == (4,4,5)
        c = copy(rb)
        rc = @inferred(reinterpretc(T, c))
        @test eltype(rc) == T && ndims(rc) == 2
        @test size(rc) == (4,5)
    end
    a = [RGB(1,0,0) RGB(0,0,1);
         RGB(0,1,0) RGB(1,1,1)]
    @test @inferred(reinterpretc(N0f8, a)) == cat([1 0; 0 1; 0 0], [0 1; 0 1; 1 1]; dims=3)
    b = BGR{N0f8}.(a)
    @test @inferred(reinterpretc(N0f8, b)) == cat([0 0; 0 1; 1 0], [1 1; 0 1; 0 1]; dims=3)
    # RGB24, ARGB32
    for sz in ((4,), (4,5))
        a = rand(UInt32, sz)
        for T in (RGB24, ARGB32)
            b = @inferred(reinterpretc(T, a))
            @test eltype(b) == T && ndims(b) == length(sz)
            @test size(b) == sz
            @test eltype(b) == T
            @test @inferred(reinterpret(UInt32, b)) == a
        end
    end

    # 1d
    a = RGB{Float64}[RGB(1,1,0)]
    af = @inferred(reinterpretc(Float64, a))
    anew = @inferred(reinterpretc(RGB, vec(af)))
    @test anew[1] == a[1]
    @test ndims(anew) == 0

    # #33 and its converse
    a = reinterpretc(BGRA{N0f8}, [0xf0884422])
    @test isa(a, AbstractVector) && a == [BGRA{N0f8}(0.533,0.267,0.133,0.941)]
    @test reinterpretc(UInt32, a) == [0xf0884422]
    @test size(reinterpretc(BGRA{N0f8}, rand(UInt32, 5, 5))) == (5,5)
    @test size(colorview(ARGB32, rand(BGRA{N0f8}, 5, 5))) == (5,5)
    a = reinterpretc(BGRA{N0f8}, reshape([0x22, 0x44, 0x88, 0xf0, 0x01, 0x02, 0x03, 0x04], 4, 2))
    @test a == [BGRA{N0f8}(0.533,0.267,0.133,0.941), BGRA{N0f8}(0.012, 0.008, 0.004, 0.016)]
    @test reinterpret(UInt8, a) == [0x22, 0x44, 0x88, 0xf0, 0x01, 0x02, 0x03, 0x04]
    @test colorview(ARGB32, a) == reinterpretc(ARGB32, [0xf0884422,0x04030201])

    # indeterminate type tests
    a = Array{RGB{AbstractFloat}}(undef, 3)
    @test_throws Union{ArgumentError,ErrorException} reinterpretc(Float64, a)
    a = Vector{RGB}(undef, 3)
    @test_throws Union{ArgumentError,ErrorException} reinterpretc(Float64, a)

    # Invalid conversions
    a = rand(UInt8, 4,5)
    ret = @test_throws TypeError reinterpretc(Gray, a)
    a = rand(Int8, 4,5)
    ret = @test_throws TypeError reinterpretc(Gray, a)
end

@testset "eltype conversion" begin
    @test float32(Float64) == Float32
    @test float32(N0f8)      == Float32
    @test float64(RGB{N0f8}) == RGB{Float64}

    a = [RGB(1,0,0) RGB(0,0,1);
         RGB(0,1,0) RGB(1,1,1)]
    @test eltype(a) == RGB{N0f8}
    @test eltype(n0f8.(a))       == RGB{N0f8}
    @test eltype(n6f10.(a)) == RGB{N6f10}
    @test eltype(n4f12.(a)) == RGB{N4f12}
    @test eltype(n2f14.(a)) == RGB{N2f14}
    @test eltype(n0f16.(a)) == RGB{N0f16}
#    @test eltype(float16.(a)) == RGB{Float16}
    @test eltype(float32.(a)) == RGB{Float32}
    @test eltype(float64.(a)) == RGB{Float64}

    a = N0f8[0.1,0.2,0.3]
    @test eltype(a) == N0f8
    @test eltype(n0f8.(a))       == N0f8
    @test eltype(n6f10.(a)) == N6f10
    @test eltype(n4f12.(a)) == N4f12
    @test eltype(n2f14.(a)) == N2f14
    @test eltype(n0f16.(a)) == N0f16
#    @test eltype(float16.(a)) == Float16
    @test eltype(float32.(a)) == Float32
    @test eltype(float64.(a)) == Float64

    a = OffsetArray(N0f8[0.1,0.2,0.3], -1:1)
    @test eltype(a) == N0f8
    @test eltype(n0f8.(a))       == N0f8
    @test eltype(n6f10.(a)) == N6f10
    @test eltype(n4f12.(a)) == N4f12
    @test eltype(n2f14.(a)) == N2f14
    @test eltype(n0f16.(a)) == N0f16
#    @test eltype(float16.(a)) == Float16
    @test eltype(float32.(a)) == Float32
    @test eltype(float64.(a)) == Float64
    @test axes(float32.(a)) == (-1:1,)

    @testset "float" begin
        # float(::Type) is equivalent to floattype
        @test @inferred(float(RGBA{Float32})) == RGBA{Float32}
        @test @inferred(float(BGR{N0f8})    ) == BGR{Float32}
        @test @inferred(float(Gray{N0f8})   ) == Gray{Float32}

        # `floattype(::Number)` is inconsistent to `float(::NUmber)`, see issue:
        # https://github.com/JuliaMath/FixedPointNumbers.jl/issues/127
        # @test @inferred(float(N0f8)         ) == Float32
        # @test @inferred(float(Bool)         ) == Float32
        # @test @inferred(float(Float32)      ) == Float32
        # @test @inferred(float(Float64)      ) == Float64

        @test @inferred(float(ARGB32)) == ARGB{Float32}
        @test @inferred(float(AGray32)) == AGray{Float32}
        @test @inferred(float(RGB24)) == RGB{Float32}
        @test @inferred(float(Gray24)) == Gray{Float32}

        # float(x::Colorant)
        @test float(oneunit(Gray{N0f8})) == oneunit(Gray{Float32})
        @test float(RGB(oneunit(Gray{N0f8}))) == RGB(oneunit(Gray{Float32}))
    end
end

@testset "convert and broadcasting" begin
    a = [RGB(1,0,0) RGB(0,0,1);
         RGB(0,1,0) RGB(1,1,1)]
    c = @inferred(convert(Array{BGR}, a))
    @test eltype(c) === BGR
    c = @inferred(convert(Array{BGR{Float32}}, a))
    @test eltype(c) === BGR{Float32}
    c = @inferred(convert(Array{Lab}, a))
    @test eltype(c) === Lab
    for a in (rand(Float32, (4,5)),
              bitrand(4,5))
        b = @inferred(convert(Array{Gray}, a))
        @test eltype(b) === Gray
        b = @inferred(convert(Array{Gray{N0f8}}, a))
        @test eltype(b) === Gray{N0f8}
    end

    # Gray images wrapped by an OffsetArray.
    A = rand(8,8)
    for img in ( Gray.(A),
                 Gray.(N0f8.(A)),
                 Gray.(N0f16.(A)) )
        imgo = OffsetArray(img, -2, -1)
        for T in (Gray{N0f8}, Gray{N0f16}, Gray{Float32})
            s = @inferred(broadcast(T, imgo))
            @test eltype(s) == T
            @test s isa OffsetArray{T,2,Array{T,2}}
            @test permutedims(permutedims(s,(2,1)),(2,1)) == s
            @test axes(s) === axes(imgo)
        end
    end

    # Color images wrapped by an OffsetArray.
    A = rand(RGB{Float32},8,8)
    for img in ( A,
                 n0f8.(A),
                 n6f10.(A),
                 n4f12.(A),
                 n2f14.(A),
                 n0f16.(A))
        imgo = OffsetArray(img, -2, -1)
        for T in (RGB{N0f8}, RGB{Float32})
            s = @inferred(broadcast(T, imgo))
            @test eltype(s) == T
            @test s isa OffsetArray{T,2,Array{T,2}}
            @test permutedims(permutedims(s,(2,1)),(2,1)) == s
            @test axes(s) === axes(imgo)
        end
    end
end


@testset "ambiguities" begin
    # issue #40
    d = Dict(:a=>1, :b=>2.0)
    @test isa(Dict(k=>v for (k,v) in d), Dict{Symbol,Real})
end

nothing

using ImageCore, Colors, ColorVectorSpace
using Test, Statistics

# Different access patterns (getindex)
function mysum_elt_boundscheck(A)
    s = zero(eltype(A))
    for a in A
        s += a
    end
    s
end
function mysum_index_boundscheck(A)
    s = zero(eltype(A))
    for I in eachindex(A)
        s += A[I]
    end
    s
end
function mysum_elt_inbounds(A)
    s = zero(eltype(A))
    @inbounds for a in A
        s += a
    end
    s
end
function mysum_index_inbounds_simd(A)
    s = zero(eltype(A))
    @inbounds @simd for I in eachindex(A)
        s += A[I]
    end
    s
end
# setindex!
function myfill1!(A, val)
    f = convert(eltype(A), val)
    for I in eachindex(A)
        A[I] = f
    end
    A
end
function myfill2!(A, val)
    f = convert(eltype(A), val)
    @inbounds @simd for I in eachindex(A)
        A[I] = f
    end
    A
end

# Rather than using BenchmarkTools (and thus run one test repeatedly,
# accumulating timings), we run the same test interleaving the two
# array types. This is designed to reduce the risk of spurious
# failure, particularly on shared machines like Travis where they may
# get "distracted" by other tasks
function test_getindex(f, ar, cv, n)
    t_ar = Array{Float64}(undef, n)
    t_cv = Array{Float64}(undef, n)
    # Store the results to prevent the compiler from eliding the call
    f_ar = Ref(f(ar))
    f_cv = Ref(f(cv))
    @test f_ar[] ≈ f_cv[]  # but this also gives us a chance to test correctness
    for i = 1:n
        t_ar[i] = (tstart = time(); f_ar[] = f(ar); time()-tstart)
        t_cv[i] = (tstart = time(); f_cv[] = f(cv); time()-tstart)
    end
    median(t_ar), median(t_cv)
end
function test_setindex(f, ar, cv, n)
    t_ar = Array{Float64}(undef, n)
    t_cv = Array{Float64}(undef, n)
    for i = 1:n
        t_ar[i] = @elapsed f(ar, zero(eltype(ar)))
        t_cv[i] = @elapsed f(cv, zero(eltype(cv)))
    end
    median(t_ar), median(t_cv)
end

cc_getindex_funcs = (mysum_elt_boundscheck,
                     mysum_index_boundscheck,
                     mysum_elt_inbounds,
                     mysum_index_inbounds_simd)
cc_setindex_funcs = (myfill1!,
                     myfill2!)

# Performance tolerances
isfast = VERSION >= v"1.6.0-DEV.1083"
chanvtol = Dict{Any,Int}(mysum_index_inbounds_simd => isfast ? 3 : 20,
                         mysum_elt_boundscheck => isfast ? 3 : 20,
                         myfill1! => 20,
                         myfill2! => isfast ? 3 : 20)
chanvdefault = isfast ? 3 : 10
colvtol = Dict{Any,Int}(mysum_elt_boundscheck=>isfast ? 3 : 5,
                        mysum_index_boundscheck=>isfast ? 3 : 5)
colvdefault = 3

ssz = (1000,300)

@info "Benchmark tests are warnings for now"
# @testset "benchmarks" begin
for T in (Float32, Float64)
    c = rand(RGB{T}, ssz...)
    a = copy(reinterpretc(T, c))
    vchan = channelview(c)
    vcol = colorview(RGB, a)

    # view versions
    rview = 2:ssz[1]-1
    csub = view(c, rview, :)
    asub = view(a, :, rview, :)
    vchansub = channelview(csub)
    vcolsub = colorview(RGB, asub)

    for (suite, testf) in ((cc_getindex_funcs, test_getindex),
                           (cc_setindex_funcs, test_setindex))
        for f in suite
            # channelview
            t_ar, t_cv = testf(f, a, vchan, 30)
            tol = haskey(chanvtol, f) ? chanvtol[f] : chanvdefault
            if t_cv >= tol*t_ar
                @warn "channelview1: failed on $f with eltype $T, time ratio $(t_cv/t_ar), tol $tol"
            end

            t_ar, t_cv = testf(f, asub, vchansub, 30)
            tol = haskey(chanvtol, f) ? chanvtol[f] : chanvdefault
            if t_cv >= tol*t_ar
                @warn "channelview2: failed on $f with eltype $T, time ratio $(t_cv/t_ar), tol $tol"
            end

            # colorview
            t_ar, t_cv = testf(f, c, vcol, 30)
            tol = haskey(colvtol, f) ? colvtol[f] : colvdefault
            if t_cv >= tol*t_ar
                @warn "colorview1: failed on $f with eltype $T, time ratio $(t_cv/t_ar), tol $tol"
            end

            t_ar, t_cv = testf(f, csub, vcolsub, 30)
            tol = haskey(colvtol, f) ? colvtol[f] : colvdefault
            if t_cv >= tol*t_ar
                @warn "colorview2: failed on $f with eltype $T, time ratio $(t_cv/t_ar), tol $tol"
            end
        end
    end
end
# end

using Documenter, ImageCore, ImageShow

format = Documenter.HTML(edit_link = "master",
                         prettyurls = get(ENV, "CI", nothing) == "true")

makedocs(modules  = [ImageCore],
         format   = format,
         sitename = "ImageCore",
         pages    = ["index.md", "views.md", "map.md", "traits.md", "reference.md"],
         warnonly = [:missing_docs, :cross_references])

deploydocs(repo   = "github.com/JuliaImages/ImageCore.jl.git")

### reinterpret

@pure samesize(::Type{T}, ::Type{S}) where {T,S} = sizeof(T) == sizeof(S)

reinterpretc(::Type{T}, a::AbstractArray) where T = reinterpret(reshape, ccolor_number(T, eltype(a)), a)
reinterpretc(::Type{T}, a::Base.ReinterpretArray{S,N,T,AA,true}) where {T,S,N,AA<:AbstractArray{T}} = parent(a)

# ccolor_number converts form 2 calls to form 1 calls
ccolor_number(::Type{T}, ::Any) where T<:Number = T
ccolor_number(::Type{CV}, ::Type{T}) where {CV<:Colorant,T} =
    ccolor_number(CV, eltype(CV), T)
ccolor_number(::Type{CV}, ::Type{CVT}, ::Type{T}) where {CV,CVT<:Number,T} = CV  # form 1
ccolor_number(::Type{CV}, ::Type{Any}, ::Type{T}) where {CV<:Colorant,T} = CV{T} # form 2

# for docstrings in the operations below
shortname(::Type{T}) where {T<:FixedPoint} = (io = IOBuffer(); FixedPointNumbers.showtype(io, T); String(take!(io)))
shortname(::Type{T}) where {T} = string(T)

# float32, float64, etc. Used for conversions like
#     Array{RGB{N0f8}} -> Array{RGB{Float32}},
# since
#    convert(Array{RGB{Float32}}, A)
# is annoyingly verbose for such a common operation.
for (fn,T) in (#(:float16, Float16),   # Float16 currently has promotion problems
               (:float32, Float32), (:float64, Float64),
               (:n0f8, N0f8), (:n6f10, N6f10),
               (:n4f12, N4f12), (:n2f14, N2f14), (:n0f16, N0f16))
    @eval begin
        ($fn)(::Type{C}) where {C<:Colorant} = base_colorant_type(C){$T}
        ($fn)(::Type{S}) where {S<:Number  } = $T
        ($fn)(c::Colorant) = convert(($fn)(typeof(c)), c)
        ($fn)(n::Number)   = convert(($fn)(typeof(n)), n)
        fname = $(Expr(:quote, fn))
        Tname = shortname($T)
@doc """
    $fname.(img)

converts the raw storage type of `img` to `$Tname`, without changing the color space.
""" $fn

    end
end

"""
    float(x::Colorant)
    float(T::Type{<:Colorant})

convert the storage type of pixel `x` to a floating point data type while
preserving the `Colorant` information.

If the input is Type `T`, then it is equivalent to [`floattype`](@ref).
"""
float(x::Colorant) = floattype(typeof(x))(x)
float(::Type{T}) where T <: Colorant = floattype(T)

using ImageCore, FixedPointNumbers, Colors, ColorVectorSpace
using Test

@testset "map" begin
    @testset "clamp01" begin
        @test clamp01(0.1) === 0.1
        @test clamp01(-0.1) === 0.0
        @test clamp01(0.9) === 0.9
        @test clamp01(1.1) === 1.0
        @test clamp01(Inf) === 1.0
        @test clamp01(-Inf) === 0.0
        @test isnan(clamp01(NaN))
        @test clamp01(N0f8(0.1)) === N0f8(0.1)
        @test clamp01(N4f12(1.2)) === N4f12(1.0)
        @test clamp01(Gray(-0.2)) === Gray(0.0)
        @test clamp01(Gray(0.7)) === Gray(0.7)
        @test clamp01(Gray(N4f12(1.2))) === Gray(N4f12(1.0))
        @test clamp01(RGB(0.2,-0.2,1.8)) === RGB(0.2,0.0,1.0)
        A = [-1.2,0.4,800.3]
        f = takemap(clamp01, A)
        fA = f.(A)
        @test eltype(fA) == Float64
        @test fA == [0.0, 0.4, 1.0]
        f = takemap(clamp01, N0f8, A)
        fA = f.(A)
        @test eltype(fA) == N0f8
        @test fA == [N0f8(0), N0f8(0.4), N0f8(1)]

        A = [-1.2,0.4,800.3]
        clamp01!(A)
        @test eltype(A) == Float64
        @test A == [0, 0.4, 1]
    end

    @testset "clamp01nan" begin
        @test clamp01nan(0.1) === 0.1
        @test clamp01nan(-0.1) === 0.0
        @test clamp01nan(0.9) === 0.9
        @test clamp01nan(1.1) === 1.0
        @test clamp01nan(Inf) === 1.0
        @test clamp01nan(-Inf) === 0.0
        @test clamp01nan(NaN) === 0.0
        @test clamp01nan(N0f8(0.1)) === N0f8(0.1)
        @test clamp01nan(N4f12(1.2)) === N4f12(1.0)
        @test clamp01nan(Gray(-0.2)) === Gray(0.0)
        @test clamp01nan(Gray(0.7)) === Gray(0.7)
        @test clamp01nan(Gray(NaN32)) === Gray(0.0f0)
        @test clamp01nan(Gray(N4f12(1.2))) === Gray(N4f12(1.0))
        @test clamp01nan(RGB(0.2,-0.2,1.8)) === RGB(0.2,0.0,1.0)
        @test clamp01nan(RGB(0.2,NaN,1.8)) === RGB(0.2,0.0,1.0)
        A = [-1.2,0.4,-Inf,NaN,Inf,800.3]
        f = takemap(clamp01nan, A)
        fA = f.(A)
        @test eltype(fA) == Float64
        @test fA == Float64[0, 0.4, 0, 0, 1, 1]
        f = takemap(clamp01nan, N0f8, A)
        fA = f.(A)
        @test eltype(fA) == N0f8
        @test fA == [N0f8(0), N0f8(0.4), N0f8(0), N0f8(0), N0f8(1), N0f8(1)]

        A = [-1.2,0.4,-Inf,NaN,Inf,800.3]
        clamp01nan!(A)
        @test eltype(A) == Float64
        @test A == [0, 0.4, 0, 0, 1, 1]
    end

    @testset "scaleminmax" begin
        A = [0, 1, 100, 1000, 2000, -7]
        target = map(x->clamp(x, 0, 1), A/1000)
        for (f, tgt) in ((scaleminmax(0, 1000), target),
                          (scaleminmax(0, 1000.0), target),
                          (scaleminmax(N0f8, 0, 1000), N0f8.(target)),
                          (scaleminmax(N0f8, 0, 1000.0), N0f8.(target)),
                          (scaleminmax(Gray, 0, 1000), Gray{Float64}.(target)),
                          (scaleminmax(Gray{N0f8}, 0, 1000.0), Gray{N0f8}.(target)))
            fA = @inferred(map(f, A))
            @test fA == tgt
            @test eltype(fA) == eltype(tgt)
        end
        B = A.+10
        f = scaleminmax(10, 1010)
        @test f.(B) == target
        A = [0, 1, 100, 1000]
        target = A/1000
        for (f, tgt) in ((takemap(scaleminmax, A), target),
                          (takemap(scaleminmax, N0f8, A), N0f8.(target)),
                          (takemap(scaleminmax, Gray{N0f8}, A), Gray{N0f8}.(target)))
            fA = @inferred(map(f, A))
            @test fA == tgt
            @test eltype(fA) == eltype(tgt)
        end
        A = [Gray(-0.1),Gray(0.1)]
        f = scaleminmax(Gray, -0.1, 0.1)
        @test f.(A) == [Gray(0.0),Gray(1.0)]
        A = reinterpretc(RGB, [0.0 128.0; 255.0 0.0; 0.0 0.0])
        f = scaleminmax(RGB, 0, 255)
        @test f.(A) == [RGB(0,1.0,0), RGB(128/255,0,0)]
        f = scaleminmax(RGB{N0f8}, 0, 255)
        @test f.(A) == [RGB(0,1,0), RGB{N0f8}(128/255,0,0)]
        f = takemap(scaleminmax, A)
        @test f.(A) == [RGB(0,1.0,0), RGB(128/255,0,0)]
        f = takemap(scaleminmax, RGB{N0f8}, A)
        @test f.(A) == [RGB(0,1,0), RGB{N0f8}(128/255,0,0)]
    end

    @testset "scalesigned" begin
        A = [-100,1000]
        target = A/1000
        for (f, tgt) in ((scalesigned(1000), target),
                         (scalesigned(-1000, 0, 1000), target),
                         (scalesigned(-1000, 0, 1000.0), target),
                         (takemap(scalesigned, A), target))
            fA = f.(A)
            @test fA == tgt
            @test eltype(fA) == eltype(tgt)
        end
    end

    @testset "colorsigned" begin
        g, w, m = colorant"green1", colorant"white", colorant"magenta"
        for f in (colorsigned(),
                  colorsigned(g, m),
                  colorsigned(g, w, m))
            @test f(-1) == g
            @test f( 0) == w
            @test f( 1) == m
            @test f(-0.5) ≈ mapc(N0f8, 0.5g+0.5w)
            @test f( 0.5) ≈ mapc(N0f8, 0.5w+0.5m)
            @test f(-0.25) ≈ mapc(N0f8, 0.25g+0.75w)
            @test f( 0.75) ≈ mapc(N0f8, 0.75m+0.25w)
            @test f(Gray(0.75)) ≈ mapc(N0f8, 0.75m+0.25w)
        end
        g, w, m = RGBA(0.,1.,0.,1.), RGBA(1.,1.,1.,0.), RGBA(1.,0.,1.,1.)
        f = colorsigned(g, w, m)
        @test f(-1) == g
        @test f( 0) == w
        @test f( 1) == m
        @test f(-0.5) ≈ RGBA(0.5,1.0,0.5,0.5)
        @test f(-0.5) ≈ 0.5g+0.5w
        @test f( 0.5) ≈ 0.5w+0.5m
        @test f(-0.25) ≈ 0.25g+0.75w
        @test f( 0.75) ≈ 0.75m+0.25w
        w = RGBA{Float64}(colorant"white")
        f = colorsigned(g, m)
        @test f(-1) == g
        @test f( 0) == w
        @test f( 1) == m
        @test f(-0.5) ≈ 0.5g+0.5w
        @test f( 0.5) ≈ 0.5w+0.5m
        @test f(-0.25) ≈ 0.25g+0.75w
        @test f( 0.75) ≈ 0.75m+0.25w
    end
end

nothing

# some views are in colorchannels.jl
using Colors, FixedPointNumbers, ImageCore, OffsetArrays, Test
using OffsetArrays: IdentityUnitRange
using PaddedViews: filltype

@testset "rawview" begin
    a = map(N0f8, rand(3,5))
    a[2,2] = N0f8(0.5)
    v = rawview(a)
    @test v[2,2] === a[2,2].i
    v[1,3] = 0xff
    @test a[1,3] === N0f8(1)
    v[1,3] = 0x01
    @test a[1,3] === N0f8(1/255)
    s = view(a, 1:2, 1:2)
    v = rawview(s)
    @test v[2,2] === a[2,2].i
    v[2,2] = 0x0f
    @test a[2,2].i == 0x0f
    @test rawview(v) === v
end

@testset "normedview" begin
    a = rand(UInt8, 3, 5)
    a[2,2] = 0x80
    v = normedview(a)
    @test v[2,2] === N0f8(0.5)
    v[1,3] = 1
    @test a[1,3] === 0xff
    v[1,3] = 1/255
    @test a[1,3] === 0x01
    s = view(a, 1:2, 1:2)
    v = normedview(s)
    @test v[2,2] === N0f8(0.5)
    v[2,2] = 15/255
    @test a[2,2] == 0x0f
    @test normedview(v) === v
    @test normedview(N0f8, v) === v
end

@testset "StackedView" begin
    for (A, B, T) = (([1 3;2 4], [-1 -5; -2 -3], Int),
                     ([1 3;2 4], [-1.0 -5.0; -2.0 -3.0], Float64))
        V = @inferred(StackedView(A, B))
        @test eltype(V) == T
        @test size(V) == (2, 2, 2)
        @test axes(V) === (Base.OneTo(2), Base.OneTo(2), Base.OneTo(2))
        @test @inferred(V[1,1,1]) === T(1)
        @test @inferred(V[2,1,1]) === T(-1)
        @test V[1,:,:] == A
        @test V[2,:,:] == B
        @test_throws BoundsError V[0,1,1]
        @test_throws BoundsError V[3,1,1]
        @test_throws BoundsError V[2,0,1]
        @test_throws BoundsError V[2,3,1]
        @test_throws BoundsError V[1,1,0]
        @test_throws BoundsError V[1,1,3]
        V32 = @inferred(StackedView{Float32}(A, B))
        @test eltype(V32) == Float32
        @test V32[1,1,2] == Float32(3)
        V[1,2,2] = 0
        @test A[2,2] == 0
        V[2,1,2] = 11
        @test B[1,2] == 11

        V = @inferred(StackedView(A, zeroarray, B))
        @test eltype(V) == T
        @test size(V) == (3, 2, 2)
        @test axes(V) === (Base.OneTo(3), Base.OneTo(2), Base.OneTo(2))
        @test V[1,:,:] == A
        @test all(iszero, V[2,:,:])
        @test V[3,:,:] == B
        err = VERSION >= v"1.8.0-rc1" ? CanonicalIndexError : ErrorException
        @test_throws err V[2,1,1] = 7
        V32 = @inferred(StackedView{Float32}(A, zeroarray, B))
        @test eltype(V32) == Float32
        @test V32[1,1,2] == Float32(3)
    end

    # With mixed grayscale/real arrays
    a, b = Gray{N0f8}[0.1 0.2; 0.3 0.4], [0.5 0.6; 0.7 0.8]
    V = @inferred(StackedView(a, b))
    @test eltype(V) == Float64
    @test V[1,1,1] === Float64(N0f8(0.1))
    @test V[2,1,1] === 0.5
    V = @inferred(StackedView{N0f8}(a, b))
    @test eltype(V) == N0f8
    @test V[1,1,1] === N0f8(0.1)
    @test V[2,1,1] === N0f8(0.5)
    @test b[1,1] === 0.5
    V = @inferred(StackedView(a, zeroarray, b))
    @test eltype(V) == Float64
    V = @inferred(StackedView{N0f8}(a, zeroarray, b))
    @test eltype(V) == N0f8

    # With colorview
    a = [0.1 0.2; 0.3 0.4]
    b = [0.5 0.6; 0.7 0.8]
    z = zeros(2,2)  # because setindex! won't work with zeroarray
    # GrayA
    v = @inferred(colorview(GrayA, a, b))
    @test eltype(v) == GrayA{Float64}
    @test @inferred(v[2,1]) === GrayA(0.3,0.7)
    v = @inferred(colorview(GrayA{N0f8}, a, b))
    @test @inferred(v[2,1]) === GrayA{N0f8}(0.3,0.7)
    v[1,2] = GrayA(0.25, 0.25)
    @test @inferred(v[1,2]) === GrayA{N0f8}(0.25, 0.25)
    v = @inferred(colorview(GrayA{N0f8}, a, zeroarray))
    @test @inferred(v[2,1]) === GrayA{N0f8}(0.3,0)
    err = VERSION >= v"1.8.0-rc1" ? CanonicalIndexError : ErrorException
    @test_throws err (v[1,2] = GrayA(0.25, 0.25))
    # RGB
    v = @inferred(colorview(RGB{N0f8}, a, zeroarray, b))
    @test @inferred(v[2,1]) === RGB{N0f8}(0.3,0,0.7)
    v = colorview(RGB{N0f8}, a, z, b)
    @test @inferred(v[2,1]) === RGB{N0f8}(0.3,0,0.7)
    v[2,1] = RGB(0,0.9,0)
    @test @inferred(v[2,1]) === RGB{N0f8}(0,0.9,0)
    @test a[2,1] == b[2,1] == 0
    @test z[2,1] == N0f8(0.9)
    # RGBA
    v = @inferred(colorview(RGBA{N0f8}, a, zeroarray, b, b))
    @test @inferred(v[2,2]) === RGBA{N0f8}(0.4,0,0.8,0.8)
    v = colorview(RGBA{N0f8}, a, copy(z), b, copy(z))
    v[2,2] = RGBA(0.75,0.8,0.75,0.8)
    @test @inferred(v[2,2]) === RGBA{N0f8}(0.75,0.8,0.75,0.8)
    @test a[2,2] == b[2,2] == N0f8(0.75)

    @test eltype(zeroarray) == Union{}
    @test_throws ErrorException colorview(RGB{N0f8}, zeroarray, zeroarray, zeroarray)
    @test_throws DimensionMismatch StackedView(rand(2,3), rand(2,5))

    # With padding
    r = reshape([0.1,0.2], 2, 1)
    g = [false true]
    cv = colorview(RGB, paddedviews(0, r, g, zeroarray)...)
    @test cv[1,1] === RGB(0.1,0,0)
    @test cv[2,1] === RGB(0.2,0,0)
    @test cv[1,2] === RGB(0,1.0,0)
    @test cv[2,2] === RGB(0,0.0,0)
    @test axes(cv) === (Base.OneTo(2), Base.OneTo(2))

    a = [0.1 0.2; 0.3 0.4]
    b = OffsetArray([0.1 0.2; 0.3 0.4], 0:1, 2:3)
    @test_throws DimensionMismatch colorview(RGB, a, b, zeroarray)
    cv = colorview(RGB, paddedviews(0, a, b, zeroarray)...)
    @test axes(cv) == (0:2, 1:3)
    @test red.(cv[axes(a)...]) == a
    @test green.(cv[axes(b)...]) == b
    @test parent(copy(cv)) == [RGB(0,0,0)   RGB(0,0.1,0)   RGB(0,0.2,0);
                               RGB(0.1,0,0) RGB(0.2,0.3,0) RGB(0,0.4,0);
                               RGB(0.3,0,0) RGB(0.4,0,0)   RGB(0,0,0)]
    chanv = channelview(cv)
    @test @inferred(axes(chanv)) == (IdentityUnitRange(1:3), IdentityUnitRange(0:2), IdentityUnitRange(1:3))
    @test chanv[1,1,1] == 0.1
    @test chanv[2,1,2] == 0.3

    @test_throws ErrorException paddedviews(0, zeroarray, zeroarray)

    # Just to boost coverage. These methods are necessary to
    # make inference happy.
    @test_throws ErrorException ImageCore._unsafe_getindex(1, (1,1))
    @test_throws ErrorException ImageCore._unsafe_setindex!(1, (1,1), 0)
end

@testset "Multi-component colorview" begin
    r, g, b = rand(Gray{N0f16},5,5), rand(Gray{N0f16},5,5), rand(Gray{N0f16},5,5)
    A = colorview(RGB, r, g, b)
    @test A[1,1] == RGB(r[1,1], g[1,1], b[1,1])
    o = ones(2, 2)
    A = colorview(RGB, o, o, zeroarray)
    @test A[1,1] == RGB(1,1,0)
    @test size(A) == (2,2)
    @test axes(A) == (Base.OneTo(2),Base.OneTo(2))
    A = colorview(RGB, o, zeroarray, o)
    @test A[1,1] == RGB(1,0,1)
    @test size(A) == (2,2)
    @test axes(A) == (Base.OneTo(2),Base.OneTo(2))
    A = colorview(RGB, zeroarray, o, o)
    @test A[1,1] == RGB(0,1,1)
    @test size(A) == (2,2)
    @test axes(A) == (Base.OneTo(2),Base.OneTo(2))
end

@testset "mosaicviews" begin
    # only test image cases
    @testset "2D inputs" begin
        A1 = fill(Gray(1.), 2, 2)
        A2 = fill(RGB(1., 0., 0.), 3, 3)
        A3 = fill(RGB(0., 1., 0.), 3, 3)
        out = mosaic(A1, A2, A3) |> collect
        @test_reference "references/mosaicviews/2d_opaque_1.png" out by=isequal
        out = mosaic(A1, A2, A3; npad=2, fillvalue=Gray(0.), nrow=2) |> collect
        @test_reference "references/mosaicviews/2d_opaque_2.png" out by=isequal
        out = mosaic(A1, A2, A3; npad=2, fillvalue=Gray(0.), nrow=2, rowmajor=true) |> collect
        @test_reference "references/mosaicviews/2d_opaque_3.png" out by=isequal

        A1 = fill(GrayA(1.), 2, 2)
        A2 = fill(RGBA(1., 0., 0.), 3, 3)
        A3 = fill(RGBA(0., 1., 0.), 3, 3)
        out = mosaic(A1, A2, A3) |> collect
        @test_reference "references/mosaicviews/2d_transparent_1.png" out by=isequal
        out = mosaic(A1, A2, A3; npad=2, fillvalue=GrayA(0., 0.), nrow=2) |> collect
        @test_reference "references/mosaicviews/2d_transparent_2.png" out by=isequal
        out = mosaic(A1, A2, A3; npad=2, fillvalue=GrayA(0., 0.), nrow=2, rowmajor=true) |> collect
        @test_reference "references/mosaicviews/2d_transparent_3.png" out by=isequal
    end

    @testset "3D inputs" begin
        A = fill(RGB(0., 0., 0.), 2, 2, 3)
        A[:, :, 1] .= RGB(1., 0., 0.)
        A[:, :, 2] .= RGB(0., 1., 0.)
        A[:, :, 3] .= RGB(0., 0., 1.)
        out = mosaic(A) |> collect
        @test_reference "references/mosaicviews/3d_opaque_1.png" out by=isequal
        out = mosaic(A; npad=2, fillvalue=Gray(0.), nrow=2) |> collect
        @test_reference "references/mosaicviews/3d_opaque_2.png" out by=isequal
        out = mosaic(A; npad=2, fillvalue=Gray(0.), nrow=2, rowmajor=true) |> collect
        @test_reference "references/mosaicviews/3d_opaque_3.png" out by=isequal
        out = mosaic(A, A; npad=2, fillvalue=Gray(0.), nrow=2) |> collect
        @test_reference "references/mosaicviews/3d_opaque_4.png" out by=isequal

        A = fill(RGBA(0., 0., 0.), 2, 2, 3)
        A[:, :, 1] .= RGBA(1., 0., 0.)
        A[:, :, 2] .= RGBA(0., 1., 0.)
        A[:, :, 3] .= RGBA(0., 0., 1.)
        out = mosaic(A) |> collect
        @test_reference "references/mosaicviews/3d_transparent_1.png" out by=isequal
        out = mosaic(A; npad=2, fillvalue=GrayA(0., 0.), nrow=2) |> collect
        @test_reference "references/mosaicviews/3d_transparent_2.png" out by=isequal
        out = mosaic(A; npad=2, fillvalue=GrayA(0.), nrow=2, rowmajor=true) |> collect
        @test_reference "references/mosaicviews/3d_transparent_3.png" out by=isequal
        out = mosaic(A, A; npad=2, fillvalue=GrayA(0.), nrow=2) |> collect
        @test_reference "references/mosaicviews/3d_transparent_4.png" out by=isequal
    end

    @testset "4D inputs" begin
        A = fill(RGB(0., 0., 0.), 2, 2, 2, 2)
        A[1, :, 1, 1] .= RGB(1., 0., 0.)
        A[:, :, 1, 2] .= RGB(0., 1., 0.)
        A[:, :, 2, 1] .= RGB(0., 0., 1.)
        out = mosaic(A) |> collect
        @test_reference "references/mosaicviews/4d_opaque_1.png" out by=isequal
        out = mosaic(A; npad=2, fillvalue=Gray(0.), nrow=2) |> collect
        @test_reference "references/mosaicviews/4d_opaque_2.png" out by=isequal
        out = mosaic(A; npad=2, fillvalue=Gray(0.), nrow=2, rowmajor=true) |> collect
        @test_reference "references/mosaicviews/4d_opaque_3.png" out by=isequal
        out = mosaic(A, A; npad=2, fillvalue=Gray(0.), nrow=2) |> collect
        @test_reference "references/mosaicviews/4d_opaque_4.png" out by=isequal

        A = fill(RGBA(0., 0., 0.), 2, 2, 2, 2)
        A[1, :, 1, 1] .= RGBA(1., 0., 0.)
        A[:, :, 1, 2] .= RGBA(0., 1., 0.)
        A[:, :, 2, 1] .= RGBA(0., 0., 1.)
        out = mosaic(A) |> collect
        @test_reference "references/mosaicviews/4d_transparent_1.png" out by=isequal
        out = mosaic(A; npad=2, fillvalue=GrayA(0., 0.), nrow=2) |> collect
        @test_reference "references/mosaicviews/4d_transparent_2.png" out by=isequal
        out = mosaic(A; npad=2, fillvalue=GrayA(0., 0.), nrow=2, rowmajor=true) |> collect
        @test_reference "references/mosaicviews/4d_transparent_3.png" out by=isequal
        out = mosaic(A, A; npad=2, fillvalue=GrayA(0.), nrow=2) |> collect
        @test_reference "references/mosaicviews/4d_transparent_4.png" out by=isequal
    end
end

@testset "PaddedViews" begin
    # cases that don't promote array eltype:
    #   * (Number, Colorant)
    #   * (Gray, Gray)
    #   * (Gray, Color3)
    #   * (Color3, Color3)
    #   * (Color3, TransparentColor)
    #   * (TransparentColor, TransparentColor)
    @test @inferred(filltype(Float32, Gray{N0f8})) == Gray{N0f8}
    @test @inferred(filltype(Float32, RGB{N0f8})) == RGB{N0f8}
    @test @inferred(filltype(Gray{Float32}, Gray{N0f8})) === Gray{N0f8}
    @test @inferred(filltype(Gray{N0f8}, Gray{Float32})) === Gray{Float32}
    @test @inferred(filltype(Gray{Float32}, RGB{N0f8})) === RGB{N0f8}
    @test @inferred(filltype(Gray{N0f8}, RGB{Float32})) === RGB{Float32}
    @test @inferred(filltype(RGB{Float32}, RGB{N0f8})) === RGB{N0f8}
    @test @inferred(filltype(RGB{N0f8}, RGB{Float32})) === RGB{Float32}
    @test @inferred(filltype(Lab{Float32}, RGB{N0f8})) === RGB{N0f8}
    @test @inferred(filltype(RGB{N0f8}, Lab{Float32})) === Lab{Float32}

    @test @inferred(filltype(Gray{N0f8}, AGray{Float32})) === AGray{Float32}
    @test @inferred(filltype(Gray{Float32}, AGray{N0f8})) === AGray{N0f8}
    @test @inferred(filltype(Gray{N0f8}, ARGB{Float32})) === ARGB{Float32}
    @test @inferred(filltype(Gray{Float32}, ARGB{N0f8})) === ARGB{N0f8}
    @test @inferred(filltype(BGR{N0f8}, ARGB{Float32})) === ARGB{Float32}
    @test @inferred(filltype(BGR{Float32}, ARGB{N0f8})) === ARGB{N0f8}
    @test @inferred(filltype(AGray{N0f8}, ARGB{Float32})) === ARGB{Float32}
    @test @inferred(filltype(AGray{Float32}, ARGB{N0f8})) === ARGB{N0f8}

    # cases that promote both colorant type and storage type
    #   * (Colorant, Number) -- numeric arrays are treated like gray images
    #   * (Color3, Gray)
    #   * (TransparentColor, Colorant)
    @test @inferred(filltype(Gray{N0f8}, Float32)) === Gray{Float32}
    @test @inferred(filltype(Gray{Float64}, Float32)) === Gray{Float32}
    @test @inferred(filltype(RGB{N0f8}, Float32)) === RGB{Float32}
    @test @inferred(filltype(RGB{Float64}, Float32)) === RGB{Float32}
    for T in (Gray24, AGray32, RGB24, ARGB32)
        @test @inferred(filltype(T, Float32)) === @inferred(filltype(Float32, T)) === T
    end

    @test @inferred(filltype(RGB{N0f8}, Gray{Float32})) === RGB{Float32}
    @test @inferred(filltype(RGB{Float32}, Gray{N0f8})) === RGB{Float32}
    @test @inferred(filltype(Lab{Float32}, Gray{N0f8})) === Lab{Float32}
    @test @inferred(filltype(Lab{Float32}, Gray{Float64})) === Lab{Float64}

    @test @inferred(filltype(AGray{N0f8}, Gray{Float32})) === AGray{Float32}
    @test @inferred(filltype(AGray{Float32}, Gray{N0f8})) === AGray{Float32}
    @test @inferred(filltype(AGray{N0f8}, RGB{Float32})) === ARGB{Float32}
    @test @inferred(filltype(AGray{Float32}, RGB{N0f8})) === ARGB{Float32}
    @test @inferred(filltype(AGray{N0f8}, Lab{Float32})) === ALab{Float32}
    @test @inferred(filltype(AGray{Float64}, Lab{Float32})) === ALab{Float64}

    @test @inferred(filltype(ARGB{N0f8}, Gray{Float32})) === ARGB{Float32}
    @test @inferred(filltype(ARGB{Float32}, Gray{N0f8})) === ARGB{Float32}
    @test @inferred(filltype(ARGB{N0f8}, BGR{Float32})) === ABGR{Float32}
    @test @inferred(filltype(ARGB{Float32}, BGR{N0f8})) === ABGR{Float32}
    @test @inferred(filltype(ARGB{N0f8}, Lab{Float32})) === ALab{Float32}
    @test @inferred(filltype(ARGB{Float64}, Lab{Float32})) === ALab{Float64}


    A = Gray{N0f8}[Gray(0.) Gray(0.3); Gray(0.6) Gray(1.)]
    fv = Gray{N0f8}(0)
    Ap = PaddedView(fv, A, (-1:4, -1:4))
    @test eltype(Ap) == Gray{N0f8}
    @test @inferred(getindex(Ap, -1, -1)) === fv
    @test @inferred(getindex(Ap, 2, 2)) === Gray{N0f8}(1.)
    @test Ap[axes(A)...] == A

    fv = RGB{Float32}(1., 0., 0.)
    Ap = PaddedView(fv, A, (-1:4, -1:4))
    @test eltype(Ap) == RGB{Float32}
    @test @inferred(getindex(Ap, -1, -1)) === fv
    @test @inferred(getindex(Ap, 2, 2)) === RGB{Float32}(1., 1., 1.)
    @test Ap[axes(A)...] == RGB{Float32}.(A)

    fv = AGray{Float32}(0.5, 0)
    Ap = PaddedView(fv, A, (-1:4, -1:4))
    @test eltype(Ap) == AGray{Float32}
    @test @inferred(getindex(Ap, -1, -1)) === fv
    @test @inferred(getindex(Ap, 2, 2)) === AGray{Float32}(1., 1.)
    @test Ap[axes(A)...] == AGray{Float32}.(A)

    fv = ARGB{Float32}(0.5, 0., 0., 0.)
    Ap = PaddedView(fv, A, (-1:4, -1:4))
    @test eltype(Ap) == ARGB{Float32}
    @test @inferred(getindex(Ap, -1, -1)) === fv
    @test @inferred(getindex(Ap, 2, 2)) === ARGB{Float32}(1., 1., 1., 1.)
    @test Ap[axes(A)...] == ARGB{Float32}.(A)

    # order irrelevant
    A = mosaic(rand(Float32, 4, 4), rand(RGB{N0f8}, 4, 4))
    @test eltype(A) == RGB{Float32}
    A = mosaic(rand(RGB{N0f8}, 4, 4), rand(Float32, 4, 4))
    @test eltype(A) == RGB{Float32}

    A = mosaic(rand(Float32, 4, 4), rand(Gray{Float64}, 4, 4))
    @test eltype(A) == Gray{Float64}
    A = mosaic(rand(Gray{Float64}, 4, 4), rand(Float32, 4, 4))
    @test eltype(A) == Gray{Float64}

    A = mosaic(rand(Float32, 4, 4), rand(Gray{Float64}, 4, 4), rand(RGB{N0f8}, 4, 4))
    @test eltype(A) == RGB{Float64}
    A = mosaic(rand(Float32, 4, 4), rand(RGB{N0f8}, 4, 4), rand(Gray{Float64}, 4, 4))
    @test eltype(A) == RGB{Float64}

    A = mosaic(rand(Gray, 4, 4), rand(RGB, 4, 4))
    @test eltype(A) == RGB{Float64} # the filltype is always a concrete type
end

nothing

# rawview
const AAFixed{T<:FixedPoint,N} = AbstractArray{T,N}
function Base.showarg(io::IO, A::MappedArray{T,N,AA,typeof(reinterpret)}, toplevel=false) where {T<:Integer,N,AA<:AAFixed}
    print(io, "rawview(")
    Base.showarg(io, parent(A), false)
    print(io, ')')
    toplevel && print(io, " with eltype ", T)
end

# normedview
const AAInteger{T<:Integer,N} = AbstractArray{T,N}
function Base.showarg(io::IO, A::MappedArray{T,N,AA,F,typeof(reinterpret)}, toplevel=false) where {T<:FixedPoint,N,AA<:AAInteger,F}
    print(io, "normedview(")
    ColorTypes.showcoloranttype(io, T)
    print(io, ", ")
    Base.showarg(io, parent(A), false)
    print(io, ')')
    toplevel && print(io, " with eltype ", T)
end

function Base.showarg(io::IO, r::Base.ReinterpretArray{T}, toplevel) where {T<:Colorant}
    print(io, "reinterpret(")
    ColorTypes.colorant_string_with_eltype(io, T)
    print(io, ", ")
    Base.showarg(io, parent(r), false)
    print(io, ')')
end

function Base.showarg(io::IO, r::Base.ReinterpretArray{T}, toplevel) where {T<:FixedPoint}
    print(io, "reinterpret(")
    ColorTypes.showcoloranttype(io, T)
    print(io, ", ")
    Base.showarg(io, parent(r), false)
    print(io, ')')
end

# Infrastructure for value transformation

"""
    clamp01(x) -> y

Produce a value `y` that lies between 0 and 1, and equal to `x` when
`x` is already in this range. Equivalent to `clamp(x, 0, 1)` for
numeric values. For colors, this function is applied to each color
channel separately.

See also: [`clamp01!`](@ref), [`clamp01nan`](@ref).
"""
clamp01(x::Union{N0f8,N0f16}) = x
clamp01(x::NumberLike) = clamp(x, zero(x), oneunit(x))
clamp01(c::Union{TransparentGray,AbstractRGB,TransparentRGB}) = mapc(clamp01, c)

"""
    clamp01!(array::AbstractArray)

Restrict values in array to [0, 1], in-place. See also [`clamp01`](@ref).
"""
function clamp01!(img::AbstractArray)
    # Slightly faster than map!(clamp01, img, img)
    @inbounds for i in eachindex(img)
        img[i] = clamp01(img[i])
    end
    img
end

"""
    clamp01nan(x) -> y

Similar to `clamp01`, except that any `NaN` values are changed to 0.

See also: [`clamp01nan!`](@ref), [`clamp01`](@ref).
"""
clamp01nan(x) = clamp01(x)
clamp01nan(x::Union{AbstractFloat,AbstractGray{<:AbstractFloat}}) = ifelse(isnan(x), zero(x), clamp01(x))
clamp01nan(c::Union{TransparentGray,AbstractRGB,TransparentRGB}) = mapc(clamp01nan, c)

"""
    clamp01nan!(array::AbstractArray)

Similar to `clamp01!`, except that any `NaN` values are changed to 0.

See also: [`clamp01!`](@ref), [`clamp01nan`](@ref)
"""
function clamp01nan!(img::GenericImage)
    # slgihtly faster than map!(clamp01nan, img, img)
    @inbounds for i in eachindex(img)
        img[i] = clamp01nan(img[i])
    end
    img
end

"""
    scaleminmax(min, max) -> f
    scaleminmax(T, min, max) -> f

Return a function `f` which maps values less than or equal to `min` to
0, values greater than or equal to `max` to 1, and uses a linear scale
in between. `min` and `max` should be real values.

Optionally specify the return type `T`. If `T` is a colorant (e.g.,
RGB), then scaling is applied to each color channel.

# Examples

## Example 1

```julia
julia> f = scaleminmax(-10, 10)
(::#9) (generic function with 1 method)

julia> f(10)
1.0

julia> f(-10)
0.0

julia> f(5)
0.75
```

## Example 2

```julia
julia> c = RGB(255.0,128.0,0.0)
RGB{Float64}(255.0,128.0,0.0)

julia> f = scaleminmax(RGB, 0, 255)
(::#13) (generic function with 1 method)

julia> f(c)
RGB{Float64}(1.0,0.5019607843137255,0.0)
```

See also: [`takemap`](@ref).
"""
function scaleminmax(min::T, max::T) where T
    @inline function(x)
        xp, minp, maxp = promote(x, min, max)  # improves performance to promote explicitly
        y = clamp(xp, minp, maxp)
        (y-minp)/(maxp-minp)
    end
end
function scaleminmax(::Type{Tout}, min::T, max::T) where {Tout,T}
    @inline function(x)
        xp, minp, maxp = promote(x, min, max)
        y = clamp(xp, minp, maxp)
        smmconvert(Tout, (y-minp)/(maxp-minp))
    end
end
@inline smmconvert(::Type{Tout}, x) where {Tout} = convert(Tout, x)
# since we know the result will be between 0 and 1, we can use rem to save a check
@inline smmconvert(::Type{Tout}, x) where {Tout<:Normed} = rem(x, Tout)

scaleminmax(min, max) = scaleminmax(promote(min, max)...)
scaleminmax(::Type{T}, min, max) where {T} = scaleminmax(T, promote(min, max)...)

# TODO: use triangular dispatch when we can count on Julia 0.6+
function scaleminmax(::Type{C}, min::T, max::T) where {C<:Colorant, T<:Real}
    _scaleminmax(C, eltype(C), min, max)
end
function _scaleminmax(::Type{C}, ::Type{TC}, min::T, max::T) where {C<:Colorant, TC<:Real, T<:Real}
    freal = scaleminmax(TC, min, max)
    @inline function(c)
        C(mapc(freal, c))
    end
end
function _scaleminmax(::Type{C}, ::Type{Any}, min::T, max::T) where {C<:Colorant, T<:Real}
    freal = scaleminmax(min, max)
    @inline function(c)
        C(mapc(freal, c))
    end
end

function takemap(::typeof(scaleminmax), A::AbstractArray{T}) where T<:Real
    min, max = extrema(A)
    scaleminmax(min, max)
end
function takemap(::typeof(scaleminmax), A::AbstractArray{C}) where C<:Colorant
    min, max = extrema(channelview(A))
    scaleminmax(C, min, max)
end
function takemap(::typeof(scaleminmax), ::Type{Tout}, A::AbstractArray{T}) where {Tout,T<:Real}
    min, max = extrema(A)
    scaleminmax(Tout, min, max)
end
function takemap(::typeof(scaleminmax), ::Type{Cout}, A::AbstractArray{C}) where {Cout<:Colorant,C<:Colorant}
    min, max = extrema(channelview(A))
    scaleminmax(Cout, min, max)
end

"""
    scalesigned(maxabs) -> f

Return a function `f` which scales values in the range `[-maxabs,
maxabs]` (clamping values that lie outside this range) to the range
`[-1, 1]`.

See also: [`colorsigned`](@ref).
"""
function scalesigned(maxabs::Real)
    maxabs > 0 || throw(ArgumentError("maxabs must be positive, got $maxabs"))
    x -> clamp(x, -maxabs, maxabs)/maxabs
end

"""
    scalesigned(min, center, max) -> f

Return a function `f` which scales values in the range `[min, center]`
to `[-1,0]` and `[center,max]` to `[0,1]`. Values smaller than
`min`/`max` get clamped to `min`/`max`, respectively.

See also: [`colorsigned`](@ref).
"""
function scalesigned(min::T, center::T, max::T) where T<:Real
    min <= center <= max || throw(ArgumentError("values must be ordered, got $min, $center, $max"))
    sneg, spos = 1/(center-min), 1/(max-center)
    function(x)
        Δy = clamp(x, min, max) - center
        ifelse(Δy < 0, sneg*Δy, spos*Δy)
    end
end
scalesigned(min::Real, center::Real, max::Real) = scalesigned(promote(min, center, max)...)

function takemap(::typeof(scalesigned), A::AbstractArray{T}) where T<:Real
    mn, mx = extrema(A)
    scalesigned(max(abs(mn), abs(mx)))
end

"""
    colorsigned()
    colorsigned(colorneg, colorpos) -> f
    colorsigned(colorneg, colorcenter, colorpos) -> f

Define a function that maps negative values (in the range [-1,0]) to
the linear colormap between `colorneg` and `colorcenter`, and positive
values (in the range [0,1]) to the linear colormap between
`colorcenter` and `colorpos`.

The default colors are:

- `colorcenter`: white
- `colorneg`: green1
- `colorpos`: magenta

See also: [`scalesigned`](@ref).
"""
colorsigned(neg::C, center::C, pos::C) where {C<:Colorant} = function(x)
    y = clamp(x, -oneunit(x), oneunit(x))
    yabs = norm(y)
    C(ifelse(y>zero(y), weighted_color_mean(yabs, pos, center),
                        weighted_color_mean(yabs, neg, center)))
end

function colorsigned(colorneg::C, colorpos::C) where C<:Colorant
    colorsigned(colorneg, C(colorant"white"), colorpos)
end

colorsigned() = colorsigned(colorant"green1", colorant"magenta")


"""
    takemap(f, A) -> fnew
    takemap(f, T, A) -> fnew

Given a value-mapping function `f` and an array `A`, return a
"concrete" mapping function `fnew`. When applied to elements of `A`,
`fnew` should return valid values for storage or display, for example
in the range from 0 to 1 (for grayscale) or valid colorants. `fnew`
may be adapted to the actual values present in `A`, and may not
produce valid values for any inputs not in `A`.

Optionally one can specify the output type `T` that `fnew` should produce.

# Example:
```julia
julia> A = [0, 1, 1000];

julia> f = takemap(scaleminmax, A)
(::#7) (generic function with 1 method)

julia> f.(A)
3-element Array{Float64,1}:
 0.0
 0.001
 1.0
```
"""
takemap

takemap(f, A) = f
takemap(f, ::Type{T}, A) where {T} = x->T(f(x))

struct StackedView{T<:Number,N,A<:Tuple{Vararg{AbstractArray{T}}}} <: AbstractArray{T,N}
    parents::A

    function StackedView{T,N,A}(parents::A) where {T<:Number,N,A<:Tuple{Vararg{AbstractArray{T}}}}
        inds = axes(parents[1])
        length(inds) == N-1 || throw(DimensionMismatch("component arrays must be of dimension \$(N-1), got \$(length(inds))"))
        for i = 2:length(parents)
            axes(parents[i]) == inds || throw(DimensionMismatch("all arrays must have the same indices, got \$inds and \$(axes(parents[i]))"))
        end
        new(parents)
    end
end

"""
    StackedView(B, C, ...) -> A

Present arrays `B`, `C`, etc, as if they are separate channels along
the first dimension of `A`. In particular,

    B == A[1,:,:...]
    C == A[2,:,:...]

and so on. Combined with `colorview`, this allows one to combine two
or more grayscale images into a single color image.

See also: [`colorview`](@ref).
"""
StackedView

@inline Base.size(V::StackedView) = (length(V.parents), size(V.parents[1])...)
@inline Base.axes(V::StackedView) = (Base.OneTo(length(V.parents)), axes(V.parents[1])...)

@inline function Base.getindex(V::StackedView{T,N}, I::Vararg{Int,N}) where {T,N}
    i1, itail = I[1], tail(I)
    P = V.parents
    @boundscheck (1 <= i1) & (i1 <= length(P)) & checkbounds(Bool, P[1], itail...) ||
        Base.throw_boundserror(V, I)
    _unsafe_getindex(i1, itail, P...)
end

@inline function Base.setindex!(V::StackedView{T,N}, val, I::Vararg{Int,N}) where {T,N}
    i1, itail = I[1], tail(I)
    P = V.parents
    @boundscheck (1 <= i1) & (i1 <= length(P)) & checkbounds(Bool, P[1], itail...) ||
        Base.throw_boundserror(V, I)
    _unsafe_setindex!(i1, itail, convert(T, val), P...)
    val
end

# This does the same thing that V.parents[i1][itail...] would do,
# except in a type-stable way. The cost is the introduction of
# branches.
@inline function _unsafe_getindex(idx, I, A::AbstractArray, As...)
    if idx == 1
        @inbounds ret = A[I...]
        return ret
    end
    _unsafe_getindex(idx-1, I, As...)
end
_unsafe_getindex(idx, I) = error("ran out of arrays; this shouldn't happen")

# For getting all of the channels (e.g., for ColorView)
@inline function _unsafe_getindex_all(I, A, As...)
    @inbounds ret = A[I...]
    (ret, _unsafe_getindex_all(I, As...)...)
end
_unsafe_getindex_all(I) = ()

@inline function _unsafe_setindex!(idx, I, val, A::AbstractArray, As...)
    if idx == 1
        @inbounds A[I...] = val
        return val
    end
    _unsafe_setindex!(idx-1, I, val, As...)
end
_unsafe_setindex!(idx, I, val) = error("ran out of arrays; this shouldn't happen")

# For setting all of the channels (e.g., for ColorView), one `val` per parent
@inline function _unsafe_setindex_all!(I, vals::NTuple{N}, As::NTuple{N,AbstractArray}) where N
    val1, valrest = vals[1], tail(vals)
    A1, Arest = As[1], tail(As)
    @inbounds A1[I...] = val1
    _unsafe_setindex_all!(I, valrest, Arest)
end
_unsafe_setindex_all!(I, ::Tuple{}, ::Tuple{}) = nothing

# Performance optimizations
@inline getchannels(P::StackedView, ::Type{C}, I) where {C<:Color2} = _unsafe_getindex_all(I, P.parents...)
@inline getchannels(P::StackedView, ::Type{C}, I) where {C<:Color3} = _unsafe_getindex_all(I, P.parents...)
@inline getchannels(P::StackedView, ::Type{C}, I) where {C<:Color4} = _unsafe_getindex_all(I, P.parents...)

@inline setchannels!(P::StackedView, val::Color2, I) = _unsafe_setindex_all!(I, (comp1(val),alpha(val)), P.parents)
@inline setchannels!(P::StackedView, val::Color3, I) = _unsafe_setindex_all!(I, (comp1(val),comp2(val),comp3(val)), P.parents)
@inline setchannels!(P::StackedView, val::Color4, I) = _unsafe_setindex_all!(I, (comp1(val),comp2(val),comp3(val),alpha(val)), P.parents)


# When overlaying 2 images, you often might want one color channel to be black
struct ZeroArrayPromise{T} end
const zeroarray = ZeroArrayPromise{Union{}}()

struct ZeroArray{T,N,R<:AbstractUnitRange} <: AbstractArray{T,N}
    inds::NTuple{N,R}
end

ZeroArrayPromise{T}(inds::Tuple{R,Vararg{R,N}}) where {T,N,R<:AbstractUnitRange} = ZeroArray{T,N+1,R}(inds)
ZeroArrayPromise{T}(inds::NTuple{N,AbstractUnitRange}) where {T,N} = ZeroArrayPromise{T}(promote(inds...))
Base.eltype(::Type{ZeroArrayPromise{T}}) where {T} = T

Base.axes(A::ZeroArray) = A.inds
Base.size(A::ZeroArray) = length.(A.inds)
Base.getindex(A::ZeroArray{T,N}, I::Vararg{Int,N}) where {T,N} = zero(T)


@inline function StackedView(arrays::Union{AbstractArray,ZeroArrayPromise}...)
    T = promote_eleltype_all(arrays...)
    stackedview(T, arrays...)
end
@inline function StackedView{T}(arrays::Union{AbstractArray,ZeroArrayPromise}...) where T<:Number
    stackedview(T, arrays...)
end

# Now, it seems we should be able to do this with uppercase-typed
# calls, but there seems to be some inference bug, and using a
# function with a different name works around it.
@inline function stackedview(::Type{T}, arrays::Union{AbstractArray,ZeroArrayPromise}...) where T<:Number
    inds = firstinds(arrays...)
    arrays_take = take_zeros(T, inds, arrays...)
    arrays_T = map(A->of_eltype(zero(T), A), arrays_take)
    # To compute N = length(inds)+1 in a type-stable fashion, we have
    # to use tuple tricks (i.e., make a tuple of length(inds)+1)
    _stackedview(T, (length(arrays), inds...), arrays_T)
end
@inline _stackedview(::Type{T}, ::Tuple{Vararg{Any,N}}, arrays) where {T,N} = StackedView{T,N,typeof(arrays)}(arrays)


@inline firstinds(A::AbstractArray, Bs...) = axes(A)
@inline firstinds(::ZeroArrayPromise, Bs...) = firstinds(Bs...)
firstinds() = error("not all arrays can be zeroarray")

@inline take_zeros(::Type{T}, inds, ::ZeroArrayPromise, Bs...) where T = (ZeroArrayPromise{T}(inds), take_zeros(T, inds, Bs...)...)
@inline take_zeros(::Type{T}, inds, A::AbstractArray, Bs...) where T = (A, take_zeros(T, inds, Bs...)...)
take_zeros(T, inds) = ()

# Extensions of PaddedViews
function PaddedViews.paddedviews(fillvalue, As::Union{AbstractArray,ZeroArrayPromise}...)
    inds = PaddedViews.outerinds(As...)
    map(A->PaddedView(fillvalue, A, inds), As)
end

PaddedViews.PaddedView(fillvalue, zap::ZeroArrayPromise, indices) = zap

@inline PaddedViews.outerinds(A::ZeroArrayPromise, Bs...) = PaddedViews.outerinds(Bs...)
@inline PaddedViews._outerinds(inds, A::ZeroArrayPromise, Bs...) =
    PaddedViews._outerinds(inds, Bs...)

module ImageCoreTests

using ImageCore
using Test, ReferenceTests
using Aqua, Documenter # for meta quality checks

@testset "Project meta quality checks" begin
    # Not checking compat section for test-only dependencies
    Aqua.test_ambiguities(ImageCore)
    Aqua.test_all(ImageCore;
                  ambiguities=false,
                  project_extras=true,
                  deps_compat=true,
                  # FIXME? failing on BlockArrays
                  stale_deps=false,
                  # FIXME? re-enable the `piracy` test
                  piracies=false, # currently just `float` and `paddedviews`
                  unbound_args=true,
    )
    DocMeta.setdocmeta!(ImageCore, :DocTestSetup, :(using ImageCore); recursive=true)
end

# ReferenceTests uses ImageInTerminal as a default image rendering backend, we need to
# temporarily disable it when we do doctest.
# TODO: ReferenceTests doesn't yet support this switch. That's why we need ImageInTerminal dependency.
using ImageInTerminal
ImageInTerminal.disable_encoding()
doctest(ImageCore, manual = false)
ImageInTerminal.enable_encoding()

include("colorchannels.jl")
include("views.jl")
include("convert_reinterpret.jl")
include("traits.jl")
include("map.jl")
Base.VERSION >= v"1.8" && include("functions.jl")   # requires @test_throws msg expr
include("show.jl")

# To ensure our deprecations work and don't break code
include("deprecations.jl")

# run these last
isCI = haskey(ENV, "CI") || get(ENV, "JULIA_PKGEVAL", false)
if Base.JLOptions().can_inline == 1 && !isCI
    @info "running benchmarks"
    include("benchmarks.jl")  # these fail if inlining is off
end

end

using PrecompileTools

let
@setup_workload begin
    function pcarray(f::F, ::Type{A}, sz) where {F,A}
        a = f(A(undef, sz))
        fill!(a, zero(eltype(a)))
        return first(a)
    end
    function pcm(a1, a2; fillvalue = zero(eltype(a1)))
        v = mosaic(a1, a2; fillvalue=fillvalue)
        return first(v)
    end
    function pcmv(a; fillvalue = zero(eltype(a)))
        v = mosaicview(a; fillvalue=fillvalue)
        return first(v)
    end

    eltypes = (N0f8, N0f16, Float32, Float64)    # eltypes of parametric colors
    pctypes = (Gray, RGB)                        # parametric colors
    cctypes = ()                                 # non-parametric colors (e.g., Gray24)
    dims  = (1, 2, 3, 4)
    szs   = ((2,), (2, 2), (2, 2, 2), (2, 2, 2, 2))
    @compile_workload begin
        for T in eltypes
            clamp01(zero(T))
            clamp01nan(zero(T))
            scaleminmax(zero(T), oneunit(T))
            scalesigned(oneunit(T))
            scalesigned(zero(T), oneunit(T) / 2, oneunit(T))
            for C in pctypes
                clamp01(zero(C{T}))
                clamp01nan(zero(C{T}))
                colorsigned(zero(C{T}), oneunit(C{T}))
            end
        end
        for C in cctypes
            clamp01(zero(C))
            clamp01nan(zero(C))
            C === AGray32 && continue
            colorsigned(zero(C), oneunit(C))
        end
        # For the arrays, it's better to make them and exercise them so we get the getindex/setindex!
        # methods precompiled too.
        for sz in szs
            for T in eltypes
                T <: FixedPoint || continue
                pcarray(rawview, Array{T,length(sz)}, sz)
            end
            pcarray(normedview, Array{UInt8,length(sz)}, sz)
            pcarray(a->normedview(N0f8, a),  Array{UInt8, length(sz)}, sz)
            pcarray(a->normedview(N0f16, a), Array{UInt16,length(sz)}, sz)
        end
        for sz in szs
            for T in eltypes
                for C in pctypes
                    nc = sizeof(C{T}) ÷ sizeof(T)
                    if nc == 1
                        pcarray(a->colorview(C,    a), Array{T,length(sz)}, sz)
                        pcarray(a->colorview(C{T}, a), Array{T,length(sz)}, sz)
                    else
                        pcarray(a->colorview(C,    a), Array{T,length(sz)+1}, (nc, sz...))
                        pcarray(a->colorview(C{T}, a), Array{T,length(sz)+1}, (nc, sz...))
                    end
                    pcarray(channelview, Array{C{T},length(sz)}, sz)
                    if T<:FixedPoint
                        R = FixedPointNumbers.rawtype(T)
                        if nc == 1
                            pcarray(a->colorview(C,    normedview(T, a)), Array{R,length(sz)}, sz)
                            pcarray(a->colorview(C{T}, normedview(T, a)), Array{R,length(sz)}, sz)
                        else
                            pcarray(a->colorview(C,    normedview(T, a)), Array{R,length(sz)+1}, (nc, sz...))
                            pcarray(a->colorview(C{T}, normedview(T, a)), Array{R,length(sz)+1}, (nc, sz...))
                        end
                    end
                end
            end
            T, C = Bool, Gray
            pcarray(a->colorview(C,    a), Array{T,length(sz)}, sz)
            pcarray(a->colorview(C{T}, a), Array{T,length(sz)}, sz)
            pcarray(channelview, Array{C{T},length(sz)}, sz)
        end
        for T in eltypes
            a = zeros(T, (2, 2))
            a3 = zeros(T, (2, 2, 2))
            pcm(a, a)
            pcmv(a3)
            for C in (Gray, RGB, GrayA, RGBA)
                a = zeros(C{T}, (2, 2))
                a3 = zeros(C{T}, (2, 2, 3))
                pcm(a, a)
                pcmv(a3)
                if C === RGB
                    pcm(a, a; fillvalue=zero(Gray{T}))
                elseif C === RGBA
                    pcm(a, a; fillvalue=zero(GrayA{T}))
                end
            end
        end
        pcm(zeros(Float32, 2, 2), zeros(Float64, 2, 2))  # heterogeneous
    end
end
end

module ImageCore

using Reexport
@reexport using FixedPointNumbers
@reexport using Colors
@reexport using ColorVectorSpace

@reexport using MosaicViews
@reexport using PaddedViews
using MappedArrays
using OffsetArrays # for show.jl
using .ColorTypes: colorant_string
using Colors: Fractional
using MappedArrays: AbstractMultiMappedArray

using Base: tail, @pure, Indices
import Base: float

# TODO: just use .+
# See https://github.com/JuliaLang/julia/pull/22932#issuecomment-330711997
plus(r::AbstractUnitRange, i::Integer) = broadcast(+, r, i)
plus(a::AbstractArray, i::Integer) = a .+ i

using .ColorTypes: AbstractGray, TransparentGray, Color3, Transparent3
const Color1{T} = Colorant{T,1}
const Color2{T} = Colorant{T,2}
const Color4{T} = Colorant{T,4}
const AColor{N,C,T} = AlphaColor{C,T,N}
const ColorA{N,C,T} = ColorAlpha{C,T,N}
const NonparametricColors = Union{RGB24,ARGB32,Gray24,AGray32}
const Color1Array{C<:Color1,N} = AbstractArray{C,N}
# Type that arises from reshape(reinterpret(To, A), sz):
const RRArray{To,From,M,P} = Base.ReinterpretArray{To,M,From,P,true}
const RGArray = Union{Base.ReinterpretArray{<:AbstractGray,M,<:Number,P}, Base.ReinterpretArray{<:Number,M,<:AbstractGray,P}} where {M,P}

# Deliberately not export these constants to enable extensibility for downstream packages
const NumberLike = Union{Number,AbstractGray}
const Pixel = Union{Number,Colorant}
const GenericGrayImage{T<:NumberLike,N} = AbstractArray{T,N}
const GenericImage{T<:Pixel,N} = AbstractArray{T,N}

export
    ## Types
    HasDimNames,
    HasProperties,
    StackedView,
    ## constants
    zeroarray,
    ## functions
    # views
    channelview,
    colorview,
    permuteddimsview,
    rawview,
    normedview,
    reinterpretc,
    # conversions
#    float16,
    float32,
    float64,
    n0f8,
    n6f10,
    n4f12,
    n2f14,
    n0f16,
    # mapping values
    clamp01,
    clamp01!,
    clamp01nan,
    clamp01nan!,
    colorsigned,
    scaleminmax,
    scalesigned,
    takemap,
    # traits
    assert_timedim_last,
    coords_spatial,
    indices_spatial,
    namedaxes,
    nimages,
    pixelspacing,
    sdims,
    size_spatial,
    spacedirections,
    spatialorder

include("colorchannels.jl")
include("stackedviews.jl")
include("convert_reinterpret.jl")
include("traits.jl")
include("map.jl")
include("show.jl")
include("deprecations.jl")

"""
    rawview(img::AbstractArray{FixedPoint})

returns a "view" of `img` where the values are interpreted in terms of
their raw underlying storage. For example, if `img` is an `Array{N0f8}`,
the view will act like an `Array{UInt8}`.

See also: [`normedview`](@ref)
"""
rawview(a::AbstractArray{T}) where {T<:FixedPoint} = mappedarray(reinterpret, y->T(y,0), a)
rawview(a::Array{T}) where {T<:FixedPoint} = reinterpret(FixedPointNumbers.rawtype(T), a)
rawview(a::AbstractArray{T}) where {T<:Real} = a

"""
    normedview([T], img::AbstractArray{Unsigned})

returns a "view" of `img` where the values are interpreted in terms of
`Normed` number types. For example, if `img` is an `Array{UInt8}`, the
view will act like an `Array{N0f8}`.  Supply `T` if the element
type of `img` is `UInt16`, to specify whether you want a `N6f10`,
`N4f12`, `N2f14`, or `N0f16` result.

See also: [`rawview`](@ref)
"""
normedview(::Type{T}, a::AbstractArray{S}) where {T<:FixedPoint,S<:Unsigned} = mappedarray(y->T(y,0),reinterpret, a)
normedview(::Type{T}, a::Array{S}) where {T<:FixedPoint,S<:Unsigned} = reinterpret(T, a)
normedview(::Type{T}, a::AbstractArray{T}) where {T<:Normed} = a
normedview(a::AbstractArray{UInt8}) = normedview(N0f8, a)
normedview(a::AbstractArray{T}) where {T<:Normed} = a

# PaddedViews support
# This make sure Colorants as `fillvalue` are correctly filled, for example, let
# `PaddedView(ARGB(0, 0, 0, 0), img)` correctly filled with transparent color even when
# `img` is of eltype `RGB`
function PaddedViews.filltype(::Type{FC}, ::Type{C}) where {FC<:Colorant, C<:Colorant}
    # rand(RGB, 4, 4) has eltype RGB{Any} but it isn't a concrete type
    # although the consensus[1] is to not make a concrete eltype, this op is needed to make a
    # type-stable colorant construction in _filltype without error; there's no RGB{Any} thing
    # [1]: https://github.com/JuliaLang/julia/pull/34948
    T = eltype(C) === Any ? eltype(FC) : eltype(C)
    _filltype(FC, base_colorant_type(C){T})
end
PaddedViews.filltype(::Type{FC}, ::Type{C}) where {FC<:Colorant, C<:Number} = base_color_type(FC){C}
PaddedViews.filltype(::Type{FC}, ::Type{<:Number}) where {FC<:Union{Gray24, AGray32, RGB24, ARGB32}} = FC
_filltype(::Type{<:Colorant}, ::Type{C}) where {C<:Colorant} = C
_filltype(::Type{FC}, ::Type{C}) where {FC<:Color3, C<:AbstractGray} =
    base_colorant_type(FC){promote_type(eltype(FC), eltype(C))}
_filltype(::Type{FC}, ::Type{C}) where {FC<:TransparentColor, C<:AbstractGray} =
    alphacolor(FC){promote_type(eltype(FC), eltype(C))}
_filltype(::Type{FC}, ::Type{C}) where {FC<:TransparentColor, C<:Color3} =
    alphacolor(C){promote_type(eltype(FC), eltype(C))}


# MosaicViews support (require MosaicViews >= v0.3.0)
MosaicViews.promote_wrapped_type(::Type{T}, ::Type{S}) where {T<:Colorant,S<:Colorant} = promote_type(T, S)
MosaicViews.promote_wrapped_type(::Type{T}, ::Type{S}) where {T,S<:Colorant} = S === Union{} ? T : base_colorant_type(S){MosaicViews.promote_wrapped_type(T, eltype(S))}
MosaicViews.promote_wrapped_type(::Type{T}, ::Type{S}) where {T<:Colorant,S} = MosaicViews.promote_wrapped_type(S, T)

# Support transpose
Base.transpose(a::AbstractMatrix{C}) where {C<:Colorant} = permutedims(a, (2,1))
function Base.transpose(a::AbstractVector{C}) where C<:Colorant
    ind = axes(a, 1)
    out = similar(Array{C}, (oftype(ind, Base.OneTo(1)), ind))
    outr = reshape(out, ind)
    copy!(outr, a)
    out
end

# It's better not to define fft on Colorant arrays, because keeping
# track of the color dimension and the fft-dims is prone to omissions
# or problems due to later operations. So we put the bookkeeping on
# the user, but we try to give helpful suggestions.
function throw_ffterror(io, @nospecialize(f), x, dims=1:ndims(x))
    newdims = plus(dims, channelview_dims_offset(x))
    print(io, '\n', f, " not defined for eltype $(eltype(x)). Use channelview, and likely $newdims for the dims in the fft.")
end

function __init__()
    Base.Experimental.register_error_hint(MethodError) do io, exc, argtypes, kwargs
        f = exc.f
        if isa(f, Function) && nameof(f) ∈ (:fft, :rfft, :plan_fft, :plan_rfft, :realfloat) && argtypes[1] <: AbstractArray{<:Colorant}
            throw_ffterror(io, exc.f, exc.args...)
        end
    end
end

include("precompile.jl")

end ## module

using ImageCore, Colors, FixedPointNumbers, OffsetArrays
using Test, Random

@info "Deprecations are expected"
@testset "permuteddimsview" begin
    a = [1 3; 2 4]
    v = permuteddimsview(a, (1,2))
    @test v == a
    v = permuteddimsview(a, (2,1))
    @test v == a'
    a = rand(3,7,5)
    v = permuteddimsview(a, (2,3,1))
    @test v == permutedims(a, (2,3,1))
end

using ImageCore, Colors, FixedPointNumbers, OffsetArrays, Test

sumsz(img) = Base.dims2string(size(img)) * ' '

const rrstr = "reshape, "
rrdim(n) = n-1

# N0f8 is shown as either N0f8 or Normed{UInt8, 8}
# RGB is shown as ColorTypes.RGB or RGB
function typestring(::Type{T}) where T
    buf = IOBuffer()
    show(buf, T)
    String(take!(buf))
end
N0f8_str = typestring(N0f8)
N0f16_str = typestring(N0f16)
RGB_str = typestring(RGB)

@testset "show" begin
    rgb32 = rand(RGB{Float32}, 3, 5)
    v = view(rgb32, 2:3, :)
    @test summary(v) == "2×5 view(::Matrix{ColorTypes.RGB{Float32}}, 2:3, :) with eltype ColorTypes.RGB{Float32}"
    a = channelview(rgb32)
    @test summary(a) == "3×3×5 reinterpret(reshape, Float32, ::Matrix{ColorTypes.RGB{Float32}}) with eltype Float32"
    num64 = rand(3,5)
    b = colorview(RGB, num64)
    str = summary(b)
    @test occursin("5-element", str) && occursin("reinterpret", str) && occursin("reshape", str) && occursin("RGB{Float64}", str) &&
          occursin("::$(typeof(num64))", str) && occursin("with eltype", str)
    rgb8 = rand(RGB{N0f8}, 3, 5)
    c = rawview(channelview(rgb8))
    str = summary(c)
    @test_broken occursin("3×3×5 rawview(reinterpret($(rrstr)", str) && occursin("N0f8", str) &&
          occursin("reshape, N0f8, ::Matrix{RGB{N0f8}}", str) && occursin("with eltype UInt8", str)
    @test_broken summary(rgb8) == "3×5 Matrix{RGB{N0f8}}"
    rand8 = rand(UInt8, 3, 5)
    d = normedview(PermutedDimsArray(rand8, (2,1)))
    @test summary(d) == "5×3 normedview(N0f8, PermutedDimsArray(::$(typeof(rand8)), (2, 1))) with eltype $(N0f8_str)"
    e = PermutedDimsArray(normedview(rand8), (2,1))
    str = summary(e)
    @test occursin("5×3 PermutedDimsArray(reinterpret", str) && occursin("N0f8", str) &&
          occursin("::$(typeof(rand8))), (2, 1)", str) && occursin("with eltype $(N0f8_str)", str)
    rand16 = rand(UInt16, 3, 5)
    f = PermutedDimsArray(normedview(N0f16, rand16), (2,1))
    str = summary(f)
    @test occursin("5×3 PermutedDimsArray(reinterpret", str) && occursin("N0f16", str) &&
          occursin("::$(typeof(rand16))), (2, 1)", str) && occursin("with eltype $(N0f16_str)", str)
    g = channelview(rgb8)
    str = summary(g)
    @test_broken occursin("3×3×5 reinterpret($(rrstr)", str) && occursin("N0f8", str) &&
          occursin("::Array{RGB{N0f8},$(rrdim(3))}", str)
    @test occursin("with eltype", str)
    h = OffsetArray(rgb8, -1:1, -2:2)
    @test_broken summary(h) == "$(sumsz(h))OffsetArray(::Array{RGB{N0f8},2}, -1:1, -2:2) with eltype $(RGB_str){$(N0f8_str)} with indices -1:1×-2:2"
    i = channelview(h)
    str = summary(i)
    @test_broken occursin("$(sumsz(i))reinterpret($(rrstr)", str) && occursin("N0f8", str) &&
          occursin("OffsetArray(::Array{RGB{N0f8},$(rrdim(3))}", str) && occursin("-1:1, -2:2", str) && occursin("with indices", str)
    c = channelview(rand(RGB{N0f8}, 2))
    o = OffsetArray(c, -1:1, 0:1)
    str = summary(o)
    @test_broken occursin("$(sumsz(o))OffsetArray(reinterpret($(rrstr)", str) && occursin("N0f8,", str) &&
          occursin("::Array{RGB{N0f8},$(rrdim(2))}", str) && occursin("-1:1, 0:1", str) && occursin("with eltype $(N0f8_str)", str) &&
          occursin("with indices", str)
    # Issue #45
    a = collect(tuple())
    @test summary(a) == "0-element $(typeof(a))"
    b = view(a, :)
    @test summary(b) == "0-element view(::$(typeof(a)), :) with eltype Union{}"
end

nothing

# Create a special type for permutations. The real point here is to be able to
# unambiguously identify an RRPermArray (see below) so that we may "unwrap" in
# expressions like `channelview(colorview(C, A))`.

"""
ColorChanPerm(perm)

Construct a reordering permutation for the color channel.
This handles swaps between memory layout and constructor argument order for `AbstractRGB` and
various `AlphaChannel` and `ChannelAlpha` color types.
"""
struct ColorChanPerm{N} <: AbstractVector{Int}
    perm::NTuple{N,Int}
end
Base.IndexStyle(::Type{<:ColorChanPerm}) = IndexLinear()
Base.size(v::ColorChanPerm{N}) where N = (N,)
Base.getindex(v::ColorChanPerm, i::Int) = v.perm[i]

dimorder(::Type{<:RGB}) = ColorChanPerm((1, 2, 3))
dimorder(::Type{<:BGR}) = ColorChanPerm((3, 2, 1))
dimorder(::Type{<:XRGB}) = ColorChanPerm((1, 1, 2, 3))
dimorder(::Type{<:RGBX}) = ColorChanPerm((1, 2, 3, 3)) # this causes problems for setindex!, fixed below
dimorder(::Type{<:BGRA}) = ColorChanPerm((3, 2, 1, 4))
dimorder(::Type{<:ABGR}) = ColorChanPerm((4, 3, 2, 1))
dimorder(::Type{<:AlphaColor{<:Color1,T,N}}) where {T,N} = ColorChanPerm((2, 1))
dimorder(::Type{<:AlphaColor{<:Color3,T,N}}) where {T,N} = ColorChanPerm((4, 1, 2, 3))

const ColorChanPermSubArray{T,N,P,I<:Tuple,L} =
    SubArray{T,N,P,I,L}
const RRPermArray{To,From,M,P<:ColorChanPermSubArray} =
    RRArray{To,From,M,P}

# This type exists solely to set multiple values in the color channel axis
struct NVector{T,N} <: AbstractVector{T}
    v::NTuple{N,T}

    NVector{T,N}(x::NTuple{N}) where {T,N} = new{T,N}(x)
end
Base.IndexStyle(::Type{<:NVector}) = IndexLinear()
Base.size(v::NVector{T,N}) where {T,N} = (N,)
Base.getindex(v::NVector, i::Int) = v.v[i]
NVector(x1::T, x::Vararg{T,N}) where {T,N} = NVector{T,N+1}((x1, x...))

@inline Base.setindex!(A::RRPermArray{<:RGBX,<:Number,N}, val::AbstractRGB, i::Vararg{Int,N}) where N =
    setindex!(parent(parent(parent(A))), NVector(red(val), green(val), blue(val)), :, i...)

"""
    channelview(A)

returns a view of `A`, splitting out (if necessary) the color channels
of `A` into a new first dimension.

Of relevance for types like RGB and BGR, the channels of the returned
array will be in constructor-argument order, not memory order (see
`reinterpretc` if you want to use memory order).

# Example
```julia
img = rand(RGB{N0f8}, 10, 10)
A = channelview(img)   # a 3×10×10 array
```

See also: [`colorview`](@ref)
"""
channelview(A::AbstractArray{T}) where {T<:Number} = A
channelview(A::RRArray{<:Colorant,<:Number}) = parent(A)
channelview(A::RRPermArray{<:Colorant,<:Number}) = parent(parent(A))
channelview(A::Base.ReinterpretArray{<:AbstractGray,M,<:Number}) where M = parent(A)
channelview(A::AbstractArray{RGB{T}}) where {T} = reinterpretc(T, A)
function channelview(A::AbstractArray{C}) where {C<:AbstractRGB}
    # BGR, XRGB, etc don't satisfy conditions for reinterpret
    CRGB = RGB{eltype(C)}
    channelview(of_eltype(CRGB, A))
end
channelview(A::AbstractArray{C}) where {C<:Color} = reinterpretc(eltype(C), A)
channelview(A::AbstractArray{C}) where {C<:ColorAlpha} = _channelview(color_type(C), A)
_channelview(::Type{<:RGB}, A) = reinterpretc(eltype(eltype(A)), A)
function _channelview(::Type{C}, A) where {C<:AbstractRGB}
    CRGBA = RGBA{eltype(C)}
    channelview(of_eltype(CRGBA, A))
end
_channelview(::Type{C}, A) where {C<:Color} = reinterpretc(eltype(C), A)
function channelview(A::AbstractArray{AC}) where {AC<:AlphaColor}
    CA = coloralpha(base_color_type(AC)){eltype(AC)}
    channelview(of_eltype(CA, A))
end

"""
    colorview(C, A)

returns a view of the numeric array `A`, interpreting successive
elements of `A` as if they were channels of Colorant `C`.

Of relevance for types like RGB and BGR, the elements of `A` are
interpreted in constructor-argument order, not memory order (see
`reinterpretc` if you want to use memory order).

# Example
```jl
A = rand(3, 10, 10)
img = colorview(RGB, A)
```

See also: [`channelview`](@ref)
"""
colorview(::Type{C}, A::AbstractArray{T}) where {C<:Colorant,T<:Number} =
    _ccolorview(ccolor_number(C, T), A)
_ccolorview(::Type{C}, A::RRPermArray{T,C}) where {C<:Colorant,T<:Number} =
    parent(parent(parent(A)))
_ccolorview(::Type{C}, A::RRArray{T,C}) where {C<:Colorant,T<:Number} =
    parent(parent(A))
_ccolorview(::Type{C}, A::Base.ReinterpretArray{T,M,C,AA,false}) where {C<:RGB,T<:Number,M,AA} =
    reshape(parent(A), Base.tail(axes(parent(A))))
# _ccolorview(::Type{C}, A::Base.ReinterpretArray{T,M,C,AA,true}) where {C<:RGB,T<:Number,M,AA} =
#     parent(A)
_ccolorview(::Type{C}, A::Base.ReinterpretArray{T,M,C,AA,false}) where {C<:Color,T<:Number,M,AA} =
    reshape(parent(A), Base.tail(axes(parent(A))))
# _ccolorview(::Type{C}, A::Base.ReinterpretArray{T,M,C,AA,true}) where {C<:Color,T<:Number,M,AA} =
#     parent(A)
_ccolorview(::Type{C}, A::AbstractArray{T}) where {C<:Colorant,T<:Number} =
    __ccolorview(C, A)  # necessary to avoid ambiguities from dispatch on eltype
__ccolorview(::Type{C}, A::AbstractArray{T}) where {T<:Number,C<:RGB{T}} = reinterpretc(C, A)
__ccolorview(::Type{C}, A::AbstractArray{T}) where {T<:Number,C<:AbstractRGB} =
    _colorview_reorder(C, A)
__ccolorview(::Type{C}, A::AbstractArray{T}) where {T<:Number,C<:Color{T}} = reinterpretc(C, A)
__ccolorview(::Type{C}, A::AbstractArray{T}) where {T<:Number,C<:ColorAlpha} =
    _colorviewalpha(base_color_type(C), C, eltype(C), A)
__ccolorview(::Type{C}, A::AbstractArray{T}) where {T<:Number,C<:AlphaColor} =
    _colorview_reorder(C, A)
_colorviewalpha(::Type{C}, ::Type{CA}, ::Type{T}, A::AbstractArray{T}) where {C<:RGB,CA,T} =
    reinterpretc(CA, A)
_colorviewalpha(::Type{C}, ::Type{CA}, ::Type{T}, A::AbstractArray{T}) where {C<:AbstractRGB,CA,T} =
    _colorview_reorder(CA, A)
_colorviewalpha(::Type{C}, ::Type{CA}, ::Type{T}, A::AbstractArray{T}) where {C<:Color,CA,T} =
    reinterpretc(CA, A)

_colorview_reorder(::Type{C}, A) where C = reinterpretc(C, view(A, dimorder(C), Base.tail(colons(A))...))

colorview(::Type{ARGB32}, A::AbstractArray{BGRA{N0f8}}) = reinterpret(ARGB32, A)

colorview(::Type{C1}, A::AbstractArray{C2}) where {C1<:Colorant,C2<:Colorant} =
    colorview(C1, channelview(A))

colons(A::AbstractArray{T,N}) where {T,N} = ntuple(d->Colon(), Val(N))

"""
    colorview(C, gray1, gray2, ...) -> imgC

Combine numeric/grayscale images `gray1`, `gray2`, etc., into the
separate color channels of an array `imgC` with element type
`C<:Colorant`.

As a convenience, the constant `zeroarray` fills in an array of
matched size with all zeros.

# Example
```julia
imgC = colorview(RGB, r, zeroarray, b)
```

creates an image with `r` in the red chanel, `b` in the blue channel,
and nothing in the green channel.

See also: [`StackedView`](@ref).
"""
function colorview(::Type{C}, gray1, gray2, grays...) where C<:Colorant
    T = _colorview_type(eltype(C), promote_eleltype_all(gray1, gray2, grays...))
    CT = base_colorant_type(C){T}
    axs = firstinds(gray1, gray2, grays...)
    mappedarray(CT, extractchannels, take_zeros(eltype(CT), axs, gray1, gray2, grays...)...)
end

"""
    colorview(C)

Create a function that is equivalent to `(As...) -> colorview(C, Ax...)`.

# Examples

```jldoctest; setup = :(using ImageCore)
julia> ones(Float32, 2, 2) |> colorview(Gray)
2×2 reinterpret(reshape, Gray{Float32}, ::Matrix{Float32}) with eltype Gray{Float32}:
 1.0  1.0
 1.0  1.0
```

This can be slightly convenient when you want to convert a batch of channel data, for example:

```julia
julia> Rs, Gs, Bs = ntuple( i -> [randn(2, 2) for _ in 1:4], 3)

julia> map(colorview(RGB), Rs, Gs, Bs)
```
"""
colorview(::Type{C}) where C<:Colorant = (As...) -> colorview(C, As...)

_colorview_type(::Type{Any}, ::Type{T}) where {T} = T
_colorview_type(::Type{T1}, ::Type{T2}) where {T1,T2} = T1

Base.@pure @inline promote_eleltype_all(gray, grays...) = _promote_eleltype_all(beltype(eltype(gray)), grays...)
@inline function _promote_eleltype_all(::Type{T}, gray, grays...) where T
    _promote_eleltype_all(promote_type(T, beltype(eltype(gray))), grays...)
end
_promote_eleltype_all(::Type{T}) where {T} = T

beltype(::Type{T}) where {T} = eltype(T)
beltype(::Type{Union{}}) = Union{}

extractchannels(c::AbstractGray)    = (gray(c),)
extractchannels(c::TransparentGray) = (gray(c), alpha(c))
extractchannels(c::Color3)          = (comp1(c), comp2(c), comp3(c))
extractchannels(c::Transparent3)    = (comp1(c), comp2(c), comp3(c), alpha(c))

## Tuple & indexing utilities

_size(A::AbstractArray) = map(length, axes(A))

# color->number
@inline channelview_size(parent::AbstractArray{C}) where {C<:Colorant} = (length(C), _size(parent)...)
@inline channelview_axes(parent::AbstractArray{C}) where {C<:Colorant} =
    _cvi(Base.OneTo(length(C)), axes(parent))
_cvi(rc, ::Tuple{}) = (rc,)
_cvi(rc, inds::Tuple{R,Vararg{R}}) where {R<:AbstractUnitRange} = (convert(R, rc), inds...)
@inline channelview_size(parent::AbstractArray{C}) where {C<:Color1} = _size(parent)
@inline channelview_axes(parent::AbstractArray{C}) where {C<:Color1} = axes(parent)

function check_ncolorchan(::AbstractArray{C}, dims) where C<:Colorant
    dims[1] == length(C) || throw(DimensionMismatch("new array has $(dims[1]) color channels, must have $(length(C))"))
end
chanparentsize(::AbstractArray{C}, dims) where {C<:Colorant} = tail(dims)
@inline colparentsize(::Type{C}, dims) where {C<:Colorant} = (length(C), dims...)

channelview_dims_offset(parent::AbstractArray{C}) where {C<:Colorant} = 1

check_ncolorchan(::AbstractArray{C}, dims) where {C<:Color1} = nothing
chanparentsize(::AbstractArray{C}, dims) where {C<:Color1} = dims
colparentsize(::Type{C}, dims) where {C<:Color1} = dims
channelview_dims_offset(parent::AbstractArray{C}) where {C<:Color1} = 0

@inline indexsplit(A::AbstractArray{C}, I) where {C<:Colorant} = I[1], tail(I)
@inline indexsplit(A::AbstractArray{C}, I) where {C<:Color1} = 1, I

# number->color
@inline colorview_size(::Type{C}, parent::AbstractArray) where {C<:Colorant} = tail(_size(parent))
@inline colorview_axes(::Type{C}, parent::AbstractArray) where {C<:Colorant} = tail(axes(parent))
@inline colorview_size(::Type{C}, parent::AbstractArray) where {C<:Color1} = _size(parent)
@inline colorview_axes(::Type{C}, parent::AbstractArray) where {C<:Color1} = axes(parent)

function checkdim1(::Type{C}, inds) where C<:Colorant
    inds[1] == (1:length(C)) || throw(DimensionMismatch("dimension 1 must have indices 1:$(length(C)), got $(inds[1])"))
    nothing
end
checkdim1(::Type{C}, dims) where {C<:Color1} = nothing

parentaxes(::Type, inds) = tail(inds)
parentaxes(::Type{C}, inds) where {C<:Color1} = inds

celtype(::Type{Any}, ::Type{T}) where {T} = T
celtype(::Type{T1}, ::Type{T2}) where {T1,T2} = T1

## Low-level color utilities

tuplify(c::Color1) = (comp1(c),)
tuplify(c::Color3) = (comp1(c), comp2(c), comp3(c))
tuplify(c::Color2) = (comp1(c), alpha(c))
tuplify(c::Color4) = (comp1(c), comp2(c), comp3(c), alpha(c))

"""
    getchannels(P, C::Type, I)

Get a tuple of all channels needed to construct a Colorant of type `C`
from an `P::AbstractArray{<:Number}`.
"""
getchannels
@inline getchannels(P, ::Type{C}, I) where {C<:Color1} = (@inbounds ret = (P[I...],); ret)
@inline getchannels(P, ::Type{C}, I::Real) where {C<:Color1} = (@inbounds ret = (P[I],); ret)
@inline function getchannels(P, ::Type{C}, I) where C<:Color2
    @inbounds ret = (P[1,I...], P[2,I...])
    ret
end
@inline function getchannels(P, ::Type{C}, I) where C<:Color3
    @inbounds ret = (P[1,I...], P[2,I...],P[3,I...])
    ret
end
@inline function getchannels(P, ::Type{C}, I) where C<:Color4
    @inbounds ret = (P[1,I...], P[2,I...], P[3,I...], P[4,I...])
    ret
end

# setchannel (similar to setfield!)
# These don't check bounds since that's already done
"""
    setchannel(c, val, idx)

Equivalent to:

    cc = copy(c)
    cc[idx] = val
    cc

for immutable colors. `idx` is interpreted in the sense of constructor
arguments, so `setchannel(c, 0.5, 1)` would set red color channel for
any `c::AbstractRGB`, even if red isn't the first field in the type.
"""
setchannel(c::Colorant{T,1}, val, Ic::Int) where {T} = typeof(c)(val)

setchannel(c::TransparentColor{C,T,2}, val, Ic::Int) where {C,T} =
    typeof(c)(ifelse(Ic==1,val,comp1(c)),
              ifelse(Ic==2,val,alpha(c)))

setchannel(c::Colorant{T,3}, val, Ic::Int) where {T} = typeof(c)(ifelse(Ic==1,val,comp1(c)),
                                                          ifelse(Ic==2,val,comp2(c)),
                                                          ifelse(Ic==3,val,comp3(c)))
setchannel(c::TransparentColor{C,T,4}, val, Ic::Int) where {C,T} =
    typeof(c)(ifelse(Ic==1,val,comp1(c)),
              ifelse(Ic==2,val,comp2(c)),
              ifelse(Ic==3,val,comp3(c)),
              ifelse(Ic==4,val,alpha(c)))

"""
    setchannels!(P, val, I)

For a color `val`, distribute its channels along `P[:, I...]` for
`P::AbstractArray{<:Number}`.
"""
setchannels!
@inline setchannels!(P, val::Color1, I) = (@inbounds P[I...] = comp1(val); val)
@inline function setchannels!(P, val::Color2, I)
    @inbounds P[1,I...] = comp1(val)
    @inbounds P[2,I...] = alpha(val)
    val
end
@inline function setchannels!(P, val::Color3, I)
    @inbounds P[1,I...] = comp1(val)
    @inbounds P[2,I...] = comp2(val)
    @inbounds P[3,I...] = comp3(val)
    val
end
@inline function setchannels!(P, val::Color4, I)
    @inbounds P[1,I...] = comp1(val)
    @inbounds P[2,I...] = comp2(val)
    @inbounds P[3,I...] = comp3(val)
    @inbounds P[4,I...] = alpha(val)
    val
end

using Colors, ImageCore, OffsetArrays, FixedPointNumbers, Test
using OffsetArrays: IdentityUnitRange
using BlockArrays

# backward-compatibility to ColorTypes < v0.9 or Colors < v0.11
using ImageCore: XRGB, RGBX

struct ArrayLF{T,N} <: AbstractArray{T,N}
    A::Array{T,N}
end
Base.IndexStyle(::Type{A}) where {A<:ArrayLF} = IndexLinear()
Base.size(A::ArrayLF) = size(A.A)
Base.getindex(A::ArrayLF, i::Int) = A.A[i]
Base.setindex!(A::ArrayLF, val, i::Int) = A.A[i] = val

struct ArrayLS{T,N} <: AbstractArray{T,N}
    A::Array{T,N}
end
Base.IndexStyle(::Type{A}) where {A<:ArrayLS} = IndexCartesian()
Base.size(A::ArrayLS) = size(A.A)
Base.getindex(A::ArrayLS{T,N}, i::Vararg{Int,N}) where {T,N} = A.A[i...]
Base.setindex!(A::ArrayLS{T,N}, val, i::Vararg{Int,N}) where {T,N} = A.A[i...] = val

@testset "ChannelView" begin

@testset "grayscale" begin
    a = rand(2,3)
    @test channelview(a) === a

    a0 = [Gray(N0f8(0.2)), Gray(N0f8(0.4))]
    for (a, LI) in ((copy(a0), IndexLinear()),
                    (ArrayLF(copy(a0)), IndexLinear()),
                    (ArrayLS(copy(a0)), IndexCartesian()))
        v = @inferred(channelview(a))
        @test @inferred(IndexStyle(v)) == LI
        @test ndims(v) == 1
        @test size(v) == (2,)
        @test eltype(v) == N0f8
        @test @inferred(colorview(Gray, v)) === a
        @test parent(parent(v)) === a
        @test v[1] == N0f8(0.2)
        @test v[2] == N0f8(0.4)
        @test_throws BoundsError v[0]
        @test_throws BoundsError v[3]
        v[1] = 0.8
        @test a[1] === Gray(N0f8(0.8))
        @test_throws BoundsError (v[0] = 0.6)
        @test_throws BoundsError (v[3] = 0.6)
        c = similar(v)
        @test eltype(c) == N0f8 && ndims(c) == 1
        @test length(c) == 2
        c = similar(v, 3)
        @test eltype(c) == N0f8 && ndims(c) == 1
        @test length(c) == 3
        c = similar(v, Float32)
        @test eltype(c) == Float32 && ndims(c) == 1
        @test length(c) == 2
        c = similar(v, Float16, (5,5))
        @test eltype(c) == Float16 && ndims(c) == 2
        @test size(c) == (5,5)
    end
end

@testset "RGB, HSV, etc" begin
    for T in (RGB, BGR, XRGB, RGBX, HSV, Lab, XYZ)
        a0 = [T(0.1,0.2,0.3), T(0.4, 0.5, 0.6)]
        for a in (copy(a0),
                  ArrayLS(copy(a0)))
            v = @inferred(channelview(a))
            @test ndims(v) == 2
            @test size(v) == (3,2)
            @test eltype(v) == Float64
            if T in (RGB, HSV, Lab, XYZ)
                @test @inferred(colorview(T, v)) == a && colorview(T, v) isa typeof(a)
            else
                @test @inferred(colorview(T, v)) == a
            end
            @test v[1] == v[1,1] == 0.1
            @test v[2] == v[2,1] == 0.2
            @test v[3] == v[3,1] == 0.3
            @test v[4] == v[1,2] == 0.4
            @test v[5] == v[2,2] == 0.5
            @test v[6] == v[3,2] == 0.6
            @test_throws BoundsError v[0,1]
            @test_throws BoundsError v[4,1]
            @test_throws BoundsError v[2,0]
            @test_throws BoundsError v[2,3]
            v[2] = 0.8
            @test a[1] == T(0.1,0.8,0.3)
            v[2,1] = 0.7
            @test a[1] == T(0.1,0.7,0.3)
            @test_throws BoundsError (v[0,1] = 0.7)
            @test_throws BoundsError (v[4,1] = 0.7)
            @test_throws BoundsError (v[2,0] = 0.7)
            @test_throws BoundsError (v[2,3] = 0.7)
            c = similar(v)
            @test size(c) == (3,2) && eltype(c) == Float64
            c = similar(v, (3,4))
            @test size(c) == (3,4) && eltype(c) == Float64
            c = similar(v, Float32)
            @test size(c) == (3,2) && eltype(c) == Float32
            c = similar(v, Float16, (3,5,5))
            @test size(c) == (3,5,5) && eltype(c) == Float16
        end
    end
    a = reshape([RGB(1,0,0)])  # 0-dimensional
    v = @inferred(channelview(a))
    @test axes(v) === (Base.OneTo(3),)
    v = @inferred(channelview(a))
    @test axes(v) === (Base.OneTo(3),)
end

@testset "Gray+Alpha" begin
    for T in (AGray, GrayA)
        a = [T(0.1f0,0.2f0), T(0.3f0,0.4f0), T(0.5f0,0.6f0)]
        v = @inferred(channelview(a))
        @test @inferred(colorview(T, v)) == a
        @test ndims(v) == 2
        @test size(v) == (2,3)
        @test eltype(v) == Float32
        @test v[1] == v[1,1] == 0.1f0
        @test v[2] == v[2,1] == 0.2f0
        @test v[3] == v[1,2] == 0.3f0
        @test v[4] == v[2,2] == 0.4f0
        @test v[5] == v[1,3] == 0.5f0
        @test v[6] == v[2,3] == 0.6f0
        @test_throws BoundsError v[0,1]
        @test_throws BoundsError v[3,1]
        @test_throws BoundsError v[2,0]
        @test_throws BoundsError v[2,4]
        v[2] = 0.8
        @test a[1] == T(0.1f0,0.8f0)
        v[2,1] = 0.7
        @test a[1] == T(0.1f0,0.7f0)
        @test_throws BoundsError (v[0,1] = 0.7)
        @test_throws BoundsError (v[3,1] = 0.7)
        @test_throws BoundsError (v[2,0] = 0.7)
        @test_throws BoundsError (v[2,4] = 0.7)
        c = similar(v)
        @test eltype(c) == Float32
        @test size(c) == (2,3)
        c = similar(v, (2,4))
        @test eltype(c) == Float32
        @test size(c) == (2,4)
        c = similar(v, Float64)
        @test eltype(c) == Float64
        @test size(c) == (2,3)
        c = similar(v, Float16, (2,5,5))
        @test eltype(c) == Float16
        @test size(c) == (2,5,5)
    end
end

@testset "Alpha+RGB, HSV, etc" begin
    for T in (ARGB,
              ABGR,
              AHSV,
              ALab,
              AXYZ,
              RGBA,
              BGRA,
              LabA,
              XYZA)
        a = [T(0.1,0.2,0.3,0.4), T(0.5,0.6,0.7,0.8)]
        v = @inferred(channelview(a))
        @test ndims(v) == 2
        @test size(v) == (4,2)
        @test eltype(v) == Float64
        @test v[1] == v[1,1] == 0.1
        @test v[2] == v[2,1] == 0.2
        @test v[3] == v[3,1] == 0.3
        @test v[4] == v[4,1] == 0.4
        @test v[5] == v[1,2] == 0.5
        @test v[6] == v[2,2] == 0.6
        @test v[7] == v[3,2] == 0.7
        @test v[8] == v[4,2] == 0.8
        @test_throws BoundsError v[0,1]
        @test_throws BoundsError v[5,1]
        @test_throws BoundsError v[2,0]
        @test_throws BoundsError v[2,3]
        v[2] = 0.9
        @test a[1] == T(0.1,0.9,0.3,0.4)
        v[2,1] = 0.7
        @test a[1] == T(0.1,0.7,0.3,0.4)
        @test_throws BoundsError (v[0,1] = 0.7)
        @test_throws BoundsError (v[5,1] = 0.7)
        @test_throws BoundsError (v[2,0] = 0.7)
        @test_throws BoundsError (v[2,3] = 0.7)
        c = similar(v)
        @test eltype(c) == Float64
        @test size(c) == (4,2)
        c = similar(v, (4,4))
        @test eltype(c) == Float64
        @test size(c) == (4,4)
        c = similar(v, Float32)
        @test eltype(c) == Float32
        @test size(c) == (4,2)
        c = similar(v, Float16, (4,5,5))
        @test eltype(c) == Float16
        @test size(c) == (4,5,5)
    end

    @testset "Non-1 indices" begin
        a = OffsetArray(rand(RGB{N0f8}, 3, 5), -1:1, -2:2)
        v = @inferred(channelview(a))
        @test @inferred(axes(v)) == (IdentityUnitRange(1:3), IdentityUnitRange(-1:1), IdentityUnitRange(-2:2))
        @test @inferred(v[1,0,0]) === a[0,0].r
        a = OffsetArray(rand(Gray{Float32}, 3, 5), -1:1, -2:2)
        v = @inferred(channelview(a))
        @test @inferred(axes(v)) == (IdentityUnitRange(-1:1), IdentityUnitRange(-2:2))
        @test @inferred(v[0,0]) === gray(a[0,0])
        @test @inferred(v[5]) === gray(a[5])
        v[5] = -1
        @test v[5] === -1.0f0
    end
end

end

@testset "ColorView" begin

@testset "grayscale" begin
    a0 = [N0f8(0.2), N0f8(0.4)]
    for (a, LI) in ((copy(a0), IndexLinear()),
                    (ArrayLF(copy(a0)), IndexLinear()),
                    (ArrayLS(copy(a0)), IndexCartesian()))
        @test_throws MethodError colorview(a)
        v = @inferred(colorview(Gray, a))
        @test colorview(Gray)(a) === colorview(Gray, a)
        @test @inferred(IndexStyle(v)) == LI
        @test ndims(v) == 1
        @test size(v) == (2,)
        @test eltype(v) == Gray{N0f8}
        @test @inferred(channelview(v)) === a
        @test parent(parent(v)) === a
        @test v[1] == Gray(N0f8(0.2))
        @test v[2] == Gray(N0f8(0.4))
        @test_throws BoundsError v[0]
        @test_throws BoundsError v[3]
        v[1] = 0.8
        @test a[1] === N0f8(0.8)
        @test_throws BoundsError (v[0] = 0.6)
        @test_throws BoundsError (v[3] = 0.6)
        c = similar(v)
        @test eltype(c) == Gray{N0f8} && ndims(c) == 1
        @test length(c) == 2
        c = similar(v, 3)
        @test eltype(c) == Gray{N0f8} && ndims(c) == 1
        @test length(c) == 3
        c = similar(v, Gray{Float32})
        @test eltype(c) == Gray{Float32}
        @test length(c) == 2
        c = similar(v, Gray{Float16}, (5,5))
        @test eltype(c) == Gray{Float16}
        @test size(c) == (5,5)
        c = similar(v, Float32)
        @test isa(c, Array{Float32, 1})
    end
    # two dimensional images and linear indexing
    a0 = N0f8[0.2 0.4; 0.6 0.8]
    for (a, LI) in ((copy(a0), IndexLinear()),
                    (ArrayLF(copy(a0)), IndexLinear()),
                    (ArrayLS(copy(a0)), IndexCartesian()))
        @test_throws MethodError colorview(a)
        v = @inferred(colorview(Gray, a))
        @test colorview(Gray)(a) === colorview(Gray, a)
        @test @inferred(IndexStyle(v)) == LI
        @test ndims(v) == 2
        @test size(v) == (2,2)
        @test eltype(v) == Gray{N0f8}
        @test @inferred(channelview(v)) === a
        @test parent(parent(v)) === a
        @test v[1] == Gray(N0f8(0.2))
        @test v[2] == Gray(N0f8(0.6))
        @test_throws BoundsError v[0]
        @test_throws BoundsError v[5]
        v[1] = 0.9
        @test a[1] === N0f8(0.9)
        @test_throws BoundsError (v[0] = 0.6)
        @test_throws BoundsError (v[5] = 0.6)
    end
end

@testset "RGB, HSV, etc" begin
    for T in (RGB, BGR, XRGB, RGBX, HSV, Lab, XYZ)
        a0 = [0.1 0.2 0.3; 0.4 0.5 0.6]'
        for a in (copy(a0),
                  ArrayLS(copy(a0)))
            v = @inferred(colorview(T,a))
            @test v === colorview(T)(a)
            @test @inferred(channelview(v)) === a
            @test ndims(v) == 1
            @test size(v) == (2,)
            @test eltype(v) == T{Float64}
            @test v[1] == T(0.1,0.2,0.3)
            @test v[2] == T(0.4,0.5,0.6)
            @test_throws BoundsError v[0]
            @test_throws BoundsError v[3]
            v[2] = T(0.8, 0.7, 0.6)
            @test a == [0.1 0.2 0.3; 0.8 0.7 0.6]'
            @test_throws BoundsError (v[0] = T(0.8, 0.7, 0.6))
            @test_throws BoundsError (v[3] = T(0.8, 0.7, 0.6))
            c = similar(v)
            @test size(c) == (2,)
            c = similar(v, 4)
            @test size(c) == (4,)
            c = similar(v, T{Float32})
            @test size(c) == (2,)
            c = similar(v, T)
            @test size(c) == (2,)
            c = similar(v, T{Float16}, (5,5))
            @test size(c) == (5,5)
            c = similar(v, RGB24)
            @test eltype(c) == RGB24
            @test size(c) == size(v)
        end
    end
end

@testset "Gray+Alpha" begin
    for T in (AGray, GrayA)
        a = [0.1f0 0.2f0; 0.3f0 0.4f0; 0.5f0 0.6f0]'
        v = @inferred(colorview(T, a))
        @test colorview(T, a) === colorview(T)(a)
        @test ndims(v) == 1
        @test size(v) == (3,)
        @test eltype(v) == T{Float32}
        @test @inferred(channelview(v)) === a
        @test v[1] == T(0.1f0, 0.2f0)
        @test v[2] == T(0.3f0, 0.4f0)
        @test v[3] == T(0.5f0, 0.6f0)
        @test_throws BoundsError v[0]
        @test_throws BoundsError v[4]
        v[2] = T(0.8, 0.7)
        @test a[1,2] === 0.8f0
        @test a[2,2] === 0.7f0
        @test_throws BoundsError (v[0] = T(0.8,0.7))
        @test_throws BoundsError (v[4] = T(0.8,0.7))
        c = similar(v)
        @test eltype(c) == T{Float32}
        @test size(c) == (3,)
        c = similar(v, (4,))
        @test eltype(c) == T{Float32}
        @test size(c) == (4,)
        c = similar(v, T{Float64})
        @test eltype(c) == T{Float64}
        @test size(c) == (3,)
        c = similar(v, T{Float16}, (5,5))
        @test eltype(c) == T{Float16}
        @test size(c) == (5,5)
    end
end

@testset "Alpha+RGB, HSV, etc" begin
    a = rand(ARGB{N0f8}, 5, 5)
    vc = @inferred(channelview(a))
    @test eltype(@inferred(colorview(ARGB, vc))) == ARGB{N0f8}
    cvc = @inferred(colorview(RGBA, vc))
    @test all(cvc .== a)

    for T in (ARGB,
              ABGR,
              AHSV,
              ALab,
              AXYZ,
              RGBA,
              BGRA,
              HSVA,
              LabA,
              XYZA)
        a = [0.1 0.2 0.3 0.4; 0.5 0.6 0.7 0.8]'
        v = @inferred(colorview(T, a))
        @test colorview(T, a) === colorview(T)(a)
        @test eltype(v) == T{Float64}
        @test @inferred(channelview(v)) === a
        @test ndims(v) == 1
        @test size(v) == (2,)
        @test eltype(v) == T{Float64}
        @test v[1] == T(0.1,0.2,0.3,0.4)
        @test v[2] == T(0.5,0.6,0.7,0.8)
        @test_throws BoundsError v[0]
        @test_throws BoundsError v[3]
        v[2] = T(0.9,0.8,0.7,0.6)
        @test a[1,2] == 0.9
        @test a[2,2] == 0.8
        @test a[3,2] == 0.7
        @test a[4,2] == 0.6
        @test_throws BoundsError (v[0] = T(0.9,0.8,0.7,0.6))
        @test_throws BoundsError (v[3] = T(0.9,0.8,0.7,0.6))
        c = similar(v)
        @test eltype(c) == T{Float64}
        @test size(c) == (2,)
        c = similar(v, 4)
        @test eltype(c) == T{Float64}
        @test size(c) == (4,)
        c = similar(v, T{Float32})
        @test eltype(c) == T{Float32}
        @test size(c) == (2,)
        c = similar(v, T{Float16}, (5,5))
        @test eltype(c) == T{Float16}
        @test size(c) == (5,5)
    end

    @testset "Non-1 indices" begin
        a = OffsetArray(rand(3, 3, 5), 1:3, -1:1, -2:2)
        v = @inferred(colorview(RGB, a))
        @test colorview(RGB, a) === colorview(RGB)(a)
        @test @inferred(axes(v)) == (IdentityUnitRange(-1:1), IdentityUnitRange(-2:2))
        @test @inferred(v[0,0]) === RGB(a[1,0,0], a[2,0,0], a[3,0,0])
        a = OffsetArray(rand(3, 3, 5), 0:2, -1:1, -2:2)
        @test_throws ArgumentError colorview(RGB, a)
    end

    @testset "Custom/divergent axis types" begin
        img1 = rand(5, 4, 2)
        img2_2 = mortar(reshape([rand(5, 4, 1), rand(5, 4, 1)], 1, 1, 2))
        img2_all = mortar(reshape([rand(5, 4, 1), rand(5, 4, 1), rand(5, 4, 1)], 1, 1, 3))
        img2_odd = img2_all[:,:,1:2:end]
        for img2 in (img2_2, img2_odd)
            for imgrgb in (colorview(RGB, img1, img2, zeroarray),
                        colorview(RGB, img2, img1, zeroarray))
                @test eltype(imgrgb) === RGB{Float64}
                @test size(imgrgb) == size(img1)
            end
        end
    end
end

end

nothing

using ImageCore, Colors, FixedPointNumbers, ColorVectorSpace, MappedArrays, OffsetArrays
using Test
using ImageCore: Pixel, NumberLike, GenericImage, GenericGrayImage, default_names

@testset "Image traits" begin
    for (B, swap) in ((rand(UInt16(1):UInt16(20), 3, 5), false),
                      (rand(Gray{Float32}, 3, 5), false),
                      (rand(RGB{Float16}, 3, 5), false),
                      (bitrand(3, 5), false),
                      (rand(UInt32, 3, 5), false),
                      (view(rand(3, 2, 5), :, 1, :), false),
                      (OffsetArray(rand(3, 5), -1:1, -2:2), false),
                      (PermutedDimsArray(rand(5, 3), (2, 1)), true),
                      (mappedarray(identity, PermutedDimsArray(rand(5, 3), (2, 1))), true),
                      (colorview(RGB, zeros(3, 5), zeroarray, zeros(3, 5)), false))
        @test pixelspacing(B) == (1,1)
        if !isa(B, SubArray)
            @test spacedirections(B) == (swap ? ((0,1),(1,0)) : ((1,0),(0,1)))
        else
            @test spacedirections(B) == ((1,0,0), (0,0,1))
        end
        @test sdims(B) == 2
        @test coords_spatial(B) == (swap ? (2,1) : (1,2))
        @test nimages(B) == 1
        @test size_spatial(B) == (3,5)
        if isa(B, OffsetArray)
            @test indices_spatial(B) == (-1:1, -2:2)
        else
            @test indices_spatial(B) == (Base.OneTo(3), Base.OneTo(5))
        end
        assert_timedim_last(B)
    end
end

# delibrately written in a redundant way
@testset "*Like traits" begin
    @testset "Pixel" begin
        @test NumberLike <: Pixel
        @test Number <: Pixel
        @test Gray <: Pixel
        @test RGB <: Pixel

        @test isa(oneunit(Gray), Pixel)
        @test isa(RGB(1.0, 0.0, 0.0), Pixel)
    end

    @testset "NumberLike" begin
        @test Number <: NumberLike
        @test Real <: NumberLike
        @test AbstractFloat <: NumberLike
        @test FixedPoint <: NumberLike
        @test Integer <: NumberLike
        @test Bool <: NumberLike

        @test Gray <: NumberLike
        @test Gray{<:AbstractFloat} <: NumberLike
        @test Gray{<:Bool} <: NumberLike

        @test isa(oneunit(Gray), NumberLike)
    end

    @testset "GenericImage" begin
        @test GenericGrayImage <: GenericImage
        for sz in Any[(3, 3), (3, 3, 3)]
            @test isa(rand(Bool, sz), GenericImage)
            @test isa(rand(N0f8, sz), GenericImage)
            @test isa(rand(Float32, sz), GenericImage)

            @test isa(rand(Gray, sz), GenericImage)
            @test isa(rand(Gray{Bool}, sz), GenericImage)
            @test isa(rand(Gray{N0f8}, sz), GenericImage)
            @test isa(rand(Gray{Float32}, sz), GenericImage)

            @test isa(rand(GrayA, sz), GenericImage)
            @test isa(rand(GrayA{N0f8}, sz), GenericImage)
            @test isa(rand(GrayA{Float32}, sz), GenericImage)

            @test isa(rand(RGB, sz), GenericImage)
            @test isa(rand(RGB{N0f8}, sz), GenericImage)
            @test isa(rand(RGB{Float32}, sz), GenericImage)

            @test isa(rand(RGBA, sz), GenericImage)
            @test isa(rand(RGBA{N0f8}, sz), GenericImage)
            @test isa(rand(RGBA{Float32}, sz), GenericImage)

            @test isa(rand(Lab, sz), GenericImage)
            @test isa(rand(Lab{Float32}, sz), GenericImage)
        end
    end

    @testset "GrayImage" begin
        for sz in [(3, 3), (3, 3, 3)]
            @test isa(rand(Bool, sz), GenericGrayImage)
            @test isa(rand(N0f8, sz), GenericGrayImage)
            @test isa(rand(Float32, sz), GenericGrayImage)

            @test isa(rand(Gray, sz), GenericGrayImage)
            @test isa(rand(Gray{Bool}, sz), GenericGrayImage)
            @test isa(rand(Gray{N0f8}, sz), GenericGrayImage)
            @test isa(rand(Gray{Float32}, sz), GenericGrayImage)
        end
    end

    @testset "dispatch" begin
        begin
            whatis(::GenericImage) = "GenericImage"
            whatis(::GenericGrayImage) = "GenericGrayImage"
            whatis(::GenericImage{<:AbstractRGB}) = "GenericRGBImage"

            whatis(::GenericImage{<:Pixel, 2}) = "Generic2dImage"
            whatis(::GenericGrayImage{<:NumberLike, 2}) = "Gray2dImage"
            whatis(::GenericImage{<:AbstractRGB, 2}) = "RGB2dImage"

            @test whatis(rand(Lab, 2, 2, 2)) == "GenericImage"

            @test whatis(rand(Lab, 2, 2)) == "Generic2dImage"

            @test whatis(rand(2, 2, 2)) == "GenericGrayImage"
            @test whatis(rand(N0f8, 2, 2, 2)) == "GenericGrayImage"
            @test whatis(rand(Bool, 2, 2, 2)) == "GenericGrayImage"
            @test whatis(rand(Float32, 2, 2, 2)) == "GenericGrayImage"
            @test whatis(rand(Int64, 2, 2, 2)) == "GenericGrayImage"

            @test whatis(rand(Gray, 2, 2, 2)) == "GenericGrayImage"
            @test whatis(rand(Gray{N0f8}, 2, 2, 2)) == "GenericGrayImage"
            @test whatis(rand(Gray{Bool}, 2, 2, 2)) == "GenericGrayImage"
            @test whatis(rand(Gray{Float32}, 2, 2, 2)) == "GenericGrayImage"

            @test whatis(rand(2, 2)) == "Gray2dImage"
            @test whatis(rand(N0f8, 2, 2)) == "Gray2dImage"
            @test whatis(rand(Bool, 2, 2)) == "Gray2dImage"
            @test whatis(rand(Float32, 2, 2)) == "Gray2dImage"
            @test whatis(rand(Int64, 2, 2)) == "Gray2dImage"

            @test whatis(rand(Gray, 2, 2)) == "Gray2dImage"
            @test whatis(rand(Gray{N0f8}, 2, 2)) == "Gray2dImage"
            @test whatis(rand(Gray{Bool}, 2, 2)) == "Gray2dImage"
            @test whatis(rand(Gray{Float32}, 2, 2)) == "Gray2dImage"

            @test whatis(rand(RGB, 2, 2, 2)) == "GenericRGBImage"
            @test whatis(rand(RGB{N0f8}, 2, 2, 2)) == "GenericRGBImage"
            @test whatis(rand(RGB{Float32}, 2, 2, 2)) == "GenericRGBImage"

            @test whatis(rand(BGR, 2, 2, 2)) == "GenericRGBImage"
            @test whatis(rand(BGR{N0f8}, 2, 2, 2)) == "GenericRGBImage"
            @test whatis(rand(BGR{Float32}, 2, 2, 2)) == "GenericRGBImage"

            @test whatis(rand(RGB, 2, 2)) == "RGB2dImage"
            @test whatis(rand(RGB{N0f8}, 2, 2)) == "RGB2dImage"
            @test whatis(rand(RGB{Float32}, 2, 2)) == "RGB2dImage"

            @test whatis(rand(BGR, 2, 2)) == "RGB2dImage"
            @test whatis(rand(BGR{N0f8}, 2, 2)) == "RGB2dImage"
            @test whatis(rand(BGR{Float32}, 2, 2)) == "RGB2dImage"
        end
    end
end

struct RowVector{T,P} <: AbstractVector{T}
    v::Vector{T}
    p::P
end

ImageCore.HasDimNames(::Type{<:RowVector}) = HasDimNames{true}()

ImageCore.HasProperties(::Type{<:RowVector}) = HasProperties{true}()

Base.names(::RowVector) = (:row,)
Base.axes(rv::RowVector) = axes(rv.v)


@testset "Trait Interface" begin
    img = reshape(1:24, 2,3,4)
    @test @inferred(namedaxes(img)) == NamedTuple{(:dim_1, :dim_2, :dim_3)}(axes(img))
    @test @inferred(HasDimNames(img)) == HasDimNames{false}()
    @test @inferred(HasProperties(img)) == HasProperties{false}()

    rv = RowVector([1:10...], Dict{String,Any}())
    @test @inferred(HasDimNames(rv)) == HasDimNames{true}()
    @test @inferred(HasProperties(rv)) == HasProperties{true}()
    @test @inferred(namedaxes(rv)) == NamedTuple{(:row,)}((Base.OneTo(10),))

    # default names
    @test @inferred(default_names(Val(3))) == (:dim_1, :dim_2, :dim_3)
end

nothing

# Lazy transformation of values

In image display and input/output, it is sometimes necessary to
transform the value (or the type) of individual pixels.  For example,
if you want to view an image with an unconventional range (e.g., -1000
to 1000, for which the normal range 0=black to 1=white will not be
very useful), then those values might need to be transformed before
display. Likewise, if try to save an image to disk that contains some
out-of-range or NaN values, you are likely to experience an error
unless the values are put in a range that makes sense for the specific
file format.

There are several approaches to handling this problem. One is to
compute a new image with scaled values, and for many users this may be
the simplest option.  However, particularly with large images (or
movies) this can present a performance problem.  In such cases, it's
better to separate the concept of the "map" (transformation) function
from the image (array) itself. (Here it's worth mentioning the
[MappedArrays](https://github.com/JuliaArrays/MappedArrays.jl)
package, which allows you to express lazy transformations on values
for an entire array.)

ImageCore contains several such transformation functions that are
frequently useful when working with images. Some of these functions
operate directly on values:

- [`clamp01`](@ref)
- [`clamp01nan`](@ref)

These two functions force the returned value to lie between 0 and 1,
or each color channel to lie between 0 and 1 for color
images. (`clamp01nan` forces `NaN` to 0, whereas `clamp01` does not
handle `NaN`.)

A simple application of these functions is in saving images, where you
may have some out-of-range values but don't care if they get
truncated:

```julia
img01 = clamp01nan.(img)
```

`img01` is safe to save to an image file, whereas trying to save `img`
might possibly result in an error (depending on the contents of
`img`).

Other functions require parameters:

- [`scaleminmax`](@ref)
- [`scalesigned`](@ref)
- [`colorsigned`](@ref)

These return a function rather than a value; that function can then
be applied to pixels of the image.  For example:

```julia
julia> f = scaleminmax(-10, 10)
(::#9) (generic function with 1 method)

julia> f(10)
1.0

julia> f(-10)
0.0

julia> f(5)
0.75
```

It's worth noting that you can combine these: for example, you can
combine `scalesigned` and `colorsigned` to map real values to linear
colormaps. For example, suppose we want to visualize some data,
mapping negative values to green hues and positive values to magenta
hues. Let's say the negative values are a bit more compressed, so
we're going to map -5 to pure green and +20 to pure magenta. We can
achieve this easily with the following:

```julia
julia> sc = scalesigned(-5, 0, 20)  # maps [-5, 0, 20] -> [-1, 0, 1]
(::#15) (generic function with 1 method)

julia> col = colorsigned()          # maps -1 -> green, +1->magenta
(::#17) (generic function with 1 method)

julia> f = x->col(sc(x))            # combine the two
(::#1) (generic function with 1 method)

julia> f(-5)
RGB{N0f8}(0.0,1.0,0.0)

julia> f(20)
RGB{N0f8}(1.0,0.0,1.0)

julia> f(0)
RGB{N0f8}(1.0,1.0,1.0)

julia> f(10)
RGB{N0f8}(1.0,0.502,1.0)
```

Finally, [`takemap`](@ref) exists to automatically set the parameters of
certain functions from the image itself.  For example,

    takemap(scaleminmax, A)

will return a function that scales the minimum value of `A` to 0 and
the maximum value of `A` to 1.

# Reference

## List of view types

With that as an introduction, let's list all the view types supported
by this package.  `channelview` and `colorview` are opposite
transformations, as are `rawview` and `normedview`. `channelview` and
`colorview` typically create objects of type `ChannelView` and
`ColorView`, respectively, unless they are "undoing" a previous view
of the opposite type.

```@docs
channelview
colorview
rawview
normedview
StackedView
```

## List of value-transformations (map functions)

```@docs
clamp01
clamp01!
clamp01nan
clamp01nan!
scaleminmax
scalesigned
colorsigned
takemap
```

## List of storage-type transformations

```@docs
float32
float64
n0f8
n6f10
n4f12
n2f14
n0f16
```

## List of traits

```@docs
pixelspacing
spacedirections
sdims
coords_spatial
size_spatial
indices_spatial
nimages
assert_timedim_last
```

# ImageCore.jl

ImageCore is the lowest-level component of the system of packages
designed to support image processing and computer vision. Its main
role is to simplify "conversions" between different image
representations through different "view" types, and to provide some
useful low-level functions (including "traits") that simplify image
display, input/output, and the writing of algorithms.

Some of the key features and functionalities provided by ImageCore.jl include:

- Storage type transformations: ImageCore.jl provides various methods like `float32`, `n0f8`, etc which can be used to transform raw storage type of the image without changing the color space. 
- Image view conversion: It provides various methods like `rawview`, `channelview`, `colorview` , `stackedview` which help in conversions between various types of representations. Default representation of images is likely all that is needed most of the time but these functions provided more flexibility while working with image data.
- Pixel level transformations: Several methods like `clamp01` , `clamp01nan`, `scaleminmax`, etc are available that help with truncating image pixel values within certain valid limits and helps to avoid IO errors.
- Image Traits: These can prove to be useful to users when trying to add more meaning to different axes of image and to add dimension specific information.


ImageCore often acts as the "common core" dependency for working with any kind of image in the JuliaImages ecosystem, but itself provides almost none of the standard image-processing algorithms. These algorithms are found in other packages in the JuliaImages ecosystem.

If you want to use ImageCore.jl, you can add it to your project environment using the package manager. Open a Julia REPL and use the following command:

```jl
] add ImageCore
```


If you're just getting started with images in Julia, it's recommended
that you see the
[introductory documentation](http://juliaimages.github.io/latest/). In
particular, this document assumes that you understand how Julia
represents color through the used of fixed-point numbers.

```@contents
Pages = ["views.md", "map.md", "traits.md", "reference.md"]
```

# Traits

ImageCore supports several "traits" that are sometimes useful in
viewing or analyzing images. Many of these traits become much more
powerful if you are using add-on packages like ImagesAxes, which
allows you to give "physical meaning" to the different axes of your
image.  Readers are encouraged to view the documentation for ImageAxes
to gain a better appreciation of how to exploit these traits.  When
using plain arrays to represent images, most of the traits default to
"trivial" outcomes.

Let's illustrate with a couple of examples:

```julia
julia> using Colors, ImageCore

julia> img = rand(RGB{N0f8}, 680, 480);

julia> pixelspacing(img)
(1,1)
```

`pixelspacing` returns the spacing between adjacent pixels along each
axis. Using ImagesAxes, you can even use physical units to encode this
information, which might be important for microscopy or biomedical imaging.

```@meta
DocTestSetup = quote
    using Colors, ImageCore
    img = rand(RGB{N0f8}, 680, 480);
end
```

Another simple trait is `coords_spatial`:

```julia
julia> coords_spatial(img)
(1,2)
```

This trait indicates that both dimensions 1 and 2 are "spatial
dimensions," meaning they correspond to physical space. This trait
again becomes more interesting with ImagesAxes, where you can denote
that some axes correspond to time (e.g., for a movie).

A full list of traits is presented in the reference section.

# Views

## View types defined in ImageCore

It is quite possible that the default representation of images will
satisfy most or all of your needs. However, to enhance flexibility in
working with image data, it is possible to leverage several different
kinds of "views." Generically, a view is an *interpretation* of array
data, one that may change the apparent meaning of the array but which
shares the same underlying storage: change an element of the view, and
you also change the original array. Views can facilitate processing images
of immense size without making copies, and writing algorithms in the
most convenient format often without having to worry about the
potential cost of converting from one format to another.

To illustrate views, it's helpful to begin with a very simple image:

```jldoctest
julia> using Colors

julia> img = [RGB(1,0,0) RGB(0,1,0);
              RGB(0,0,1) RGB(0,0,0)]
2×2 Matrix{RGB{FixedPointNumbers.N0f8}}:
 RGB(1.0, 0.0, 0.0)  RGB(0.0, 1.0, 0.0)
 RGB(0.0, 0.0, 1.0)  RGB(0.0, 0.0, 0.0)
```

which displays as

![rgbk](assets/rgbk.png)

```@meta
DocTestSetup = quote
    using Colors, ImageCore
    img = [RGB(1,0,0) RGB(0,1,0);
           RGB(0,0,1) RGB(0,0,0)]
    v = channelview(img)
    r = rawview(v)
end
```

Most commonly, it's convenient that all dimensions of this array
correspond to pixel indices: you don't need to worry about some
dimensions of the array corresponding to "color channels" and other
the spatial location, and you're guaranteed to get the entire pixel
contents when you access that location.

That said, occasionally there are reasons to want to treat `RGB` as a
3-component vector.  That's motivation for introducing our first view:

```jldoctest
julia> v = channelview(img)
3×2×2 reinterpret(reshape, N0f8, ::Matrix{RGB{N0f8}}) with eltype N0f8:
[:, :, 1] =
 1.0  0.0
 0.0  0.0
 0.0  1.0

[:, :, 2] =
 0.0  0.0
 1.0  0.0
 0.0  0.0
```

`channelview` does exactly what the name suggests: provide a view of
the array using separate channels for the color components.

To access the underlying representation of the `N0f8` numbers, there's
another view called `rawview`:

```jldoctest
julia> r = rawview(v)
3×2×2 rawview(reinterpret(reshape, N0f8, ::Matrix{RGB{N0f8}})) with eltype UInt8:
[:, :, 1] =
 0xff  0x00
 0x00  0x00
 0x00  0xff

[:, :, 2] =
 0x00  0x00
 0xff  0x00
 0x00  0x00
```

Let's make a change in one of the entries:

```jldoctest
julia> r[3,1,1] = 128
128
```

If we display `img`, now we get this:

![mgbk](assets/mgbk.png)

You can see that the first pixel has taken on a magenta hue, which is
a mixture of red and blue.  Why does this happen? Let's look at the
array values themselves:

```@meta
DocTestSetup = quote
    using Colors, ImageCore
    img = [RGB(1,0,0) RGB(0,1,0);
           RGB(0,0,1) RGB(0,0,0)]
    v = channelview(img)
    r = rawview(v)
    r[3,1,1] = 128
end
```

```jldoctest
julia> r
3×2×2 rawview(reinterpret(reshape, N0f8, ::Matrix{RGB{N0f8}})) with eltype UInt8:
[:, :, 1] =
 0xff  0x00
 0x00  0x00
 0x80  0xff

[:, :, 2] =
 0x00  0x00
 0xff  0x00
 0x00  0x00

julia> v
3×2×2 reinterpret(reshape, N0f8, ::Matrix{RGB{N0f8}}) with eltype N0f8:
[:, :, 1] =
 1.0    0.0
 0.0    0.0
 0.502  1.0

[:, :, 2] =
 0.0  0.0
 1.0  0.0
 0.0  0.0

julia> img
2×2 Matrix{RGB{N0f8}}:
 RGB(1.0, 0.0, 0.502)  RGB(0.0, 1.0, 0.0)
 RGB(0.0, 0.0, 1.0)    RGB(0.0, 0.0, 0.0)
```

The hexadecimal representation of 128 is 0x80; this is approximately
halfway to 255, and as a consequence the `N0f8` representation is
very near 0.5.  You can see the same change is reflected in `r`, `v`,
and `img`: there is only one underlying array, `img`, and the two
views simply reference it.

Maybe you're used to having the color channel be the last dimension,
rather than the first. We can achieve that using `PermutedDimsArray`:

```jldoctest
julia> p = PermutedDimsArray(v, (2,3,1))
2×2×3 PermutedDimsArray(reinterpret(reshape, N0f8, ::Matrix{RGB{N0f8}}), (2, 3, 1)) with eltype N0f8:
[:, :, 1] =
 1.0  0.0
 0.0  0.0

[:, :, 2] =
 0.0  1.0
 0.0  0.0

[:, :, 3] =
 0.502  0.0
 1.0    0.0

julia> p[1,2,:] .= 0.25
3-element view(PermutedDimsArray(reinterpret(reshape, N0f8, ::Matrix{RGB{N0f8}}), (2, 3, 1)), 1, 2, :) with eltype N0f8:
 0.251N0f8
 0.251N0f8
 0.251N0f8

julia> p
2×2×3 PermutedDimsArray(reinterpret(reshape, N0f8, ::Matrix{RGB{N0f8}}), (2, 3, 1)) with eltype N0f8:
[:, :, 1] =
 1.0  0.251
 0.0  0.0

[:, :, 2] =
 0.0  0.251
 0.0  0.0

[:, :, 3] =
 0.502  0.251
 1.0    0.0

julia> v
3×2×2 reinterpret(reshape, N0f8, ::Matrix{RGB{N0f8}}) with eltype N0f8:
[:, :, 1] =
 1.0    0.0
 0.0    0.0
 0.502  1.0

[:, :, 2] =
 0.251  0.0
 0.251  0.0
 0.251  0.0

julia> img
2×2 Matrix{RGB{N0f8}}:
 RGB(1.0, 0.0, 0.502)  RGB(0.251, 0.251, 0.251)
 RGB(0.0, 0.0, 1.0)    RGB(0.0, 0.0, 0.0)
```

Once again, `p` is a view, and as a consequence changing it leads to
changes in all the coupled arrays and views.

Finally, you can combine multiple arrays into a "virtual" multichannel
array. We'll use the
[lighthouse](http://juliaimages.github.io/TestImages.jl/images/lighthouse.png)
image:

```@example
using ImageCore, TestImages, Colors
img = testimage("lighthouse")
# Split out into separate channels
cv = channelview(img)
# Recombine the channels, filling in 0 for the middle (green) channel
rb = colorview(RGB, cv[1,:,:], zeroarray, cv[3,:,:])
```

`zeroarray` is a constant which serves as a placeholder to create a
(virtual) all-zeros array of size that matches the other arguments.

`rb` looks like this:

![redblue](assets/redblue.png)

In this case, we could have done the same thing somewhat more simply
with `cv[2,:,:] .= 0` and then visualize `img`. However, more generally
you can apply this to independent arrays which may not allow you to
set values to 0. In IJulia,

![linspace1](assets/linspace1.png)

The error comes from the fact that `img1d` does not store values
separately from the `LinSpace` objects used to create it, and
`LinSpace` (which uses a compact representation of a range, storing
just the endpoints and the number of values) does not allow you to set
specific values. However, if you need to set individual values, you
can make a `copy`:

![linspace2](assets/linspace2.png)

The fact that no storage is allocated by `colorview`
is very convenient in certain situations, particularly when processing
large images.

`colorview`'s ability to combine multiple grayscale images is based on
another view, `StackedView`, which you can also use directly.
